/*
  J[Nmap]  un fully front-end per Nmap Security Scanner programmato in Java. L'interfaccia grafica 
   stata implementata utilizzando le librerie javax.Swing e java.AWT.
  
  J[Nmap]  stato programmato da Dario Maggiari. 
*/

import java.io.*;
import java.util.*;

public class Jnmap extends javax.swing.JFrame
   {  
    private String command_nmap = null;
    private String s_oX = "";
    private String s_oG = "";
    private String s_oA = "";
    private String s_oS = "";
    private String s_iL = "";
    
    /**
      Costruttore della classe. Richiama nel suo body il metodo initComponents che contiene tutti gli elementi
      grafici da visualizzare al lancio del front-end.
    */
    public Jnmap() {
        initComponents();
    }
    
    /**
      Metodo per la definizione degli elementi grafici da visualizzare al lancio del front-end.
    */
    private void initComponents() {//GEN-BEGIN:initComponents
        FileChooser = new javax.swing.JFileChooser();
        GroupSmode = new javax.swing.ButtonGroup();
        jPMenu_helpT = new javax.swing.JPopupMenu();
        Text_helpT = new javax.swing.JTextArea();
        Globalpane = new javax.swing.JPanel();
        Tabbed = new javax.swing.JTabbedPane();
        tab_scanmode = new javax.swing.JPanel();
        PanelExclmode = new javax.swing.JPanel();
        sS = new javax.swing.JCheckBox();
        sF = new javax.swing.JCheckBox();
        sT = new javax.swing.JCheckBox();
        sW = new javax.swing.JCheckBox();
        sX = new javax.swing.JCheckBox();
        sP = new javax.swing.JCheckBox();
        sA = new javax.swing.JCheckBox();
        sN = new javax.swing.JCheckBox();
        sL = new javax.swing.JCheckBox();
        sM = new javax.swing.JCheckBox();
        sO = new javax.swing.JCheckBox();
        PanelSmode = new javax.swing.JPanel();
        sI = new javax.swing.JCheckBox();
        tfield_sI = new javax.swing.JTextField();
        b = new javax.swing.JCheckBox();
        tfield_b = new javax.swing.JTextField();
        PanelCombmode = new javax.swing.JPanel();
        sV = new javax.swing.JCheckBox();
        sep1_smo = new javax.swing.JLabel();
        sR = new javax.swing.JCheckBox();
        sep1_smo1 = new javax.swing.JLabel();
        sU = new javax.swing.JCheckBox();
        sep1_smo2 = new javax.swing.JLabel();
        I = new javax.swing.JCheckBox();
        sep1_smo3 = new javax.swing.JLabel();
        O = new javax.swing.JCheckBox();
        PanelHelp = new javax.swing.JPanel();
        button_oh = new javax.swing.JButton();
        sep2_smo = new javax.swing.JLabel();
        label_inforoot = new javax.swing.JLabel();
        tab_goptions = new javax.swing.JPanel();
        Panel_C1 = new javax.swing.JPanel();
        Panel_Pingo = new javax.swing.JPanel();
        P0 = new javax.swing.JCheckBox();
        PB = new javax.swing.JCheckBox();
        PE = new javax.swing.JCheckBox();
        PP = new javax.swing.JCheckBox();
        PM = new javax.swing.JCheckBox();
        PU = new javax.swing.JCheckBox();
        sep5 = new javax.swing.JLabel();
        PU_port = new javax.swing.JTextField();
        PA = new javax.swing.JCheckBox();
        PA_port = new javax.swing.JTextField();
        PS = new javax.swing.JCheckBox();
        sep7 = new javax.swing.JLabel();
        PS_port = new javax.swing.JTextField();
        Panel_DNSo = new javax.swing.JPanel();
        n = new javax.swing.JCheckBox();
        R = new javax.swing.JCheckBox();
        Panel_C2 = new javax.swing.JPanel();
        Panel_Ports = new javax.swing.JPanel();
        p_all = new javax.swing.JCheckBox();
        sep8 = new javax.swing.JLabel();
        p = new javax.swing.JCheckBox();
        p_TCPport = new javax.swing.JTextField();
        sep3 = new javax.swing.JLabel();
        p_UDPport = new javax.swing.JTextField();
        M = new javax.swing.JCheckBox();
        M_infos = new javax.swing.JTextField();
        e = new javax.swing.JCheckBox();
        e_infos = new javax.swing.JTextField();
        source_port = new javax.swing.JCheckBox();
        source_port_infos = new javax.swing.JTextField();
        exclude = new javax.swing.JCheckBox();
        exclude_infos = new javax.swing.JTextField();
        S = new javax.swing.JCheckBox();
        S_infos = new javax.swing.JTextField();
        Panel_Verbosity = new javax.swing.JPanel();
        v = new javax.swing.JCheckBox();
        d = new javax.swing.JCheckBox();
        Panel_C3 = new javax.swing.JPanel();
        Panel_Misc = new javax.swing.JPanel();
        F = new javax.swing.JCheckBox();
        ipv6 = new javax.swing.JCheckBox();
        r = new javax.swing.JCheckBox();
        randomize_hosts = new javax.swing.JCheckBox();
        osscan_limit = new javax.swing.JCheckBox();
        data_length = new javax.swing.JCheckBox();
        data_length_infos = new javax.swing.JTextField();
        ttl = new javax.swing.JCheckBox();
        ttl_infos = new javax.swing.JTextField();
        iR = new javax.swing.JCheckBox();
        iR_infos = new javax.swing.JTextField();
        Panel_Genius = new javax.swing.JPanel();
        D = new javax.swing.JCheckBox();
        D_infos = new javax.swing.JTextField();
        f = new javax.swing.JCheckBox();
        tab_timing = new javax.swing.JPanel();
        Panel_T1 = new javax.swing.JPanel();
        Panel_Thrott = new javax.swing.JPanel();
        T = new javax.swing.JCheckBox();
        T_cbox = new javax.swing.JComboBox();
        T_cbox.addItem("Paranoid");
        T_cbox.addItem("Sneaky");
        T_cbox.addItem("Polite");
        T_cbox.addItem("Normal");
        T_cbox.addItem("Aggressive");
        T_cbox.addItem("Insane");
        info_crash = new javax.swing.JLabel();
        button_helpT = new javax.swing.JButton();
        Panel_TDO = new javax.swing.JPanel();
        initial_rtt_to = new javax.swing.JCheckBox();
        sep11 = new javax.swing.JLabel();
        initial_rtt_to_ms = new javax.swing.JTextField();
        ms = new javax.swing.JLabel();
        host_timeout = new javax.swing.JCheckBox();
        host_timeout_ms = new javax.swing.JTextField();
        ms6 = new javax.swing.JLabel();
        max_rtt_to = new javax.swing.JCheckBox();
        sep2 = new javax.swing.JLabel();
        max_rtt_to_ms = new javax.swing.JTextField();
        ms1 = new javax.swing.JLabel();
        min_rtt_to = new javax.swing.JCheckBox();
        sep4 = new javax.swing.JLabel();
        min_rtt_to_ms = new javax.swing.JTextField();
        ms2 = new javax.swing.JLabel();
        min_sd = new javax.swing.JCheckBox();
        sep6 = new javax.swing.JLabel();
        min_sd_s = new javax.swing.JTextField();
        ms5 = new javax.swing.JLabel();
        max_sd = new javax.swing.JCheckBox();
        sep9 = new javax.swing.JLabel();
        max_sd_s = new javax.swing.JTextField();
        ms7 = new javax.swing.JLabel();
        Panel_T2 = new javax.swing.JPanel();
        Panel_Parallel = new javax.swing.JPanel();
        max_par = new javax.swing.JCheckBox();
        max_par_n = new javax.swing.JTextField();
        min_par = new javax.swing.JCheckBox();
        sep10 = new javax.swing.JLabel();
        min_par_n = new javax.swing.JTextField();
        max_hostgroup = new javax.swing.JCheckBox();
        max_hostgroup_infos = new javax.swing.JTextField();
        min_hostgroup = new javax.swing.JCheckBox();
        min_hostgroup_infos = new javax.swing.JTextField();
        tab_specials = new javax.swing.JPanel();
        Panel_space = new javax.swing.JPanel();
        Panel_oX = new javax.swing.JPanel();
        oX = new javax.swing.JCheckBox();
        label_path = new javax.swing.JLabel();
        text_path = new javax.swing.JTextField();
        select_button = new javax.swing.JButton();
        Panel_oG = new javax.swing.JPanel();
        oG = new javax.swing.JCheckBox();
        label_path1 = new javax.swing.JLabel();
        text_path1 = new javax.swing.JTextField();
        select_button1 = new javax.swing.JButton();
        Panel_oS = new javax.swing.JPanel();
        oS = new javax.swing.JCheckBox();
        label_path3 = new javax.swing.JLabel();
        text_path3 = new javax.swing.JTextField();
        select_button3 = new javax.swing.JButton();
        Panel_oA = new javax.swing.JPanel();
        oA = new javax.swing.JCheckBox();
        label_path2 = new javax.swing.JLabel();
        text_path2 = new javax.swing.JTextField();
        select_button2 = new javax.swing.JButton();
        Panel_iL = new javax.swing.JPanel();
        iL = new javax.swing.JCheckBox();
        label_path4 = new javax.swing.JLabel();
        text_path4 = new javax.swing.JTextField();
        select_button4 = new javax.swing.JButton();
        tab_running = new javax.swing.JPanel();
        Panel_ErrIm = new javax.swing.JPanel();
        iconscan = new javax.swing.JLabel();
        Scroll_error = new javax.swing.JScrollPane();
        text_errorsr = new javax.swing.JTextArea();
        Panel_RSS = new javax.swing.JPanel();
        Panel_RSS1 = new javax.swing.JPanel();
        label_ht = new javax.swing.JLabel();
        label_cht = new javax.swing.JLabel();
        Panel_RSS2 = new javax.swing.JPanel();
        label_cn = new javax.swing.JLabel();
        label_cnmap = new javax.swing.JLabel();
        Panel_RSS3 = new javax.swing.JPanel();
        label_ssi = new javax.swing.JLabel();
        label_ssc = new javax.swing.JLabel();
        Panel_RSS4 = new javax.swing.JPanel();
        label_ss = new javax.swing.JLabel();
        label_ssrt = new javax.swing.JLabel();
        tab_scan = new javax.swing.JPanel();
        Scrolltextres = new javax.swing.JScrollPane();
        textresult = new javax.swing.JTextArea();
        Panelresults = new javax.swing.JPanel();
        button_saveres = new javax.swing.JButton();
        label_sepsr = new javax.swing.JLabel();
        button_reset = new javax.swing.JButton();
        tab_credits = new javax.swing.JPanel();
        label_logo = new javax.swing.JLabel();
        Panel_credits = new javax.swing.JPanel();
        Text_credits1 = new javax.swing.JTextArea();
        Text_credits2 = new javax.swing.JTextArea();
        Text_credits3 = new javax.swing.JTextArea();
        Startpane = new javax.swing.JPanel();
        button_kill = new javax.swing.JButton();
        label_separator1 = new javax.swing.JLabel();
        labelip = new javax.swing.JLabel();
        textip = new javax.swing.JTextField();
        label_separator = new javax.swing.JLabel();
        button_scan = new javax.swing.JButton();

        FileChooser.setCurrentDirectory(new java.io.File("/home"));
        jPMenu_helpT.setBorder(null);
        jPMenu_helpT.setEnabled(false);
        jPMenu_helpT.setOpaque(false);
        Text_helpT.setFont(new java.awt.Font("Dialog", 0, 11));
        Text_helpT.setText("  \n  Paranoid: [Very slow - Hig crash chance!] - Waits 5 minutes between send packs.  \n\n  Sneaky: [Very slow  - Hig crash chance!] - Waits 15 seconds between send packs.\n\n  Polite: [Slow  - Slow crash chance!]  - Waits 0,4 seconds between send packs.\n\n  Normal: [Normal - NO crash chance.]  \n\n  Aggressive: [Fast - NO crash chance.] \n\n  Insane: [Quick - NO crash chance.]\n");
        Text_helpT.setBorder(null);
        Text_helpT.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        Text_helpT.setEnabled(false);
        Text_helpT.setOpaque(false);

        getContentPane().setLayout(new java.awt.FlowLayout());

        setTitle("J[Nmap]  Ver. 3.81 -- [Powered By Dario Maggiari aKa nEcR0SoFt]");
        setName("globalframe");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        Globalpane.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        Globalpane.setPreferredSize(new java.awt.Dimension(790, 490));
        Globalpane.setOpaque(false);
        Tabbed.setToolTipText("");
        Tabbed.setFont(new java.awt.Font("Dialog", 0, 12));
        Tabbed.setName("");
        Tabbed.setPreferredSize(new java.awt.Dimension(790, 450));
        tab_scanmode.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 0, 12));

        tab_scanmode.setToolTipText("");
        tab_scanmode.setName("Scan Mode");
        tab_scanmode.setOpaque(false);
        PanelExclmode.setLayout(new java.awt.GridLayout(4, 3, 0, 6));

        PanelExclmode.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "Scanner Mode Selection", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), null));
        PanelExclmode.setPreferredSize(new java.awt.Dimension(785, 195));
        PanelExclmode.setOpaque(false);
        sS.setFont(new java.awt.Font("Dialog", 0, 11));
        sS.setText("-sS [TCP  SYN Stealth scan]*");
        GroupSmode.add(sS);
        sS.setOpaque(false);
        PanelExclmode.add(sS);

        sF.setFont(new java.awt.Font("Dialog", 0, 11));
        sF.setText("-sF [FIN Stealth scan]*");
        GroupSmode.add(sF);
        sF.setOpaque(false);
        PanelExclmode.add(sF);

        sT.setFont(new java.awt.Font("Dialog", 0, 11));
        sT.setSelected(true);
        sT.setText("-sT [TCP  connect() scan]");
        GroupSmode.add(sT);
        sT.setOpaque(false);
        sT.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                sTItemStateChanged(evt);
            }
        });

        PanelExclmode.add(sT);

        sW.setFont(new java.awt.Font("Dialog", 0, 11));
        sW.setText("-sW [TCP Window scan]*");
        GroupSmode.add(sW);
        sW.setOpaque(false);
        PanelExclmode.add(sW);

        sX.setFont(new java.awt.Font("Dialog", 0, 11));
        sX.setText("-sX [Xmas Tree Stealth scan]*");
        GroupSmode.add(sX);
        sX.setOpaque(false);
        PanelExclmode.add(sX);

        sP.setFont(new java.awt.Font("Dialog", 0, 11));
        sP.setText("-sP [Ping Sweep scan]");
        GroupSmode.add(sP);
        sP.setOpaque(false);
        sP.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                sPItemStateChanged(evt);
            }
        });

        PanelExclmode.add(sP);

        sA.setFont(new java.awt.Font("Dialog", 0, 11));
        sA.setText("-sA [ACK Stealth scan]*");
        sA.setToolTipText("");
        GroupSmode.add(sA);
        sA.setOpaque(false);
        PanelExclmode.add(sA);

        sN.setFont(new java.awt.Font("Dialog", 0, 11));
        sN.setText("-sN [Null Stealth scan]*");
        GroupSmode.add(sN);
        sN.setOpaque(false);
        PanelExclmode.add(sN);

        sL.setFont(new java.awt.Font("Dialog", 0, 11));
        sL.setText("-sL [Host List scan]");
        GroupSmode.add(sL);
        sL.setOpaque(false);
        sL.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                sLItemStateChanged(evt);
            }
        });

        PanelExclmode.add(sL);

        sM.setFont(new java.awt.Font("Dialog", 0, 11));
        sM.setText("-sM [FIN/ACK Stealth scan]*");
        GroupSmode.add(sM);
        sM.setOpaque(false);
        PanelExclmode.add(sM);

        sO.setFont(new java.awt.Font("Dialog", 0, 11));
        sO.setText("-s0 [IP scan]*");
        GroupSmode.add(sO);
        sO.setOpaque(false);
        sO.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                sOItemStateChanged(evt);
            }
        });

        PanelExclmode.add(sO);

        tab_scanmode.add(PanelExclmode);

        PanelSmode.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 0, 10));

        PanelSmode.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "Special Scanner Mode", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), null));
        PanelSmode.setPreferredSize(new java.awt.Dimension(785, 95));
        PanelSmode.setOpaque(false);
        sI.setFont(new java.awt.Font("Dialog", 0, 11));
        sI.setText("-sI <zombie host[:probeport]> [Idlescan]* :");
        GroupSmode.add(sI);
        sI.setPreferredSize(new java.awt.Dimension(275, 22));
        sI.setOpaque(false);
        sI.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                sIItemStateChanged(evt);
            }
        });
        sI.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                sIMouseClicked(evt);
            }
        });

        PanelSmode.add(sI);

        tfield_sI.setPreferredSize(new java.awt.Dimension(480, 21));
        tfield_sI.setEnabled(false);
        PanelSmode.add(tfield_sI);

        b.setFont(new java.awt.Font("Dialog", 0, 11));
        b.setText("-b <ftp relay host> [FTP bounce attack]* :");
        GroupSmode.add(b);
        b.setPreferredSize(new java.awt.Dimension(275, 22));
        b.setOpaque(false);
        b.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                bItemStateChanged(evt);
            }
        });
        b.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                bMouseClicked(evt);
            }
        });

        PanelSmode.add(b);

        tfield_b.setPreferredSize(new java.awt.Dimension(480, 21));
        tfield_b.setEnabled(false);
        PanelSmode.add(tfield_b);

        tab_scanmode.add(PanelSmode);

        PanelCombmode.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 0, 7));

        PanelCombmode.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "Scanner Mode Options", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), null));
        PanelCombmode.setPreferredSize(new java.awt.Dimension(785, 58));
        PanelCombmode.setOpaque(false);
        sV.setFont(new java.awt.Font("Dialog", 0, 11));
        sV.setSelected(true);
        sV.setText("-sV [Version detection]");
        sV.setOpaque(false);
        PanelCombmode.add(sV);

        sep1_smo.setPreferredSize(new java.awt.Dimension(15, 0));
        PanelCombmode.add(sep1_smo);

        sR.setFont(new java.awt.Font("Dialog", 0, 11));
        sR.setText("-sR [RPC scan]");
        sR.setOpaque(false);
        sR.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                sRItemStateChanged(evt);
            }
        });

        PanelCombmode.add(sR);

        sep1_smo1.setPreferredSize(new java.awt.Dimension(15, 0));
        PanelCombmode.add(sep1_smo1);

        sU.setFont(new java.awt.Font("Dialog", 0, 11));
        sU.setText("-sU [UDP scan]*");
        sU.setOpaque(false);
        sU.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                sUItemStateChanged(evt);
            }
        });

        PanelCombmode.add(sU);

        sep1_smo2.setPreferredSize(new java.awt.Dimension(15, 0));
        PanelCombmode.add(sep1_smo2);

        I.setFont(new java.awt.Font("Dialog", 0, 11));
        I.setText("-I [Identscan]*");
        I.setEnabled(false);
        I.setOpaque(false);
        PanelCombmode.add(I);

        sep1_smo3.setPreferredSize(new java.awt.Dimension(15, 0));
        PanelCombmode.add(sep1_smo3);

        O.setFont(new java.awt.Font("Dialog", 0, 11));
        O.setSelected(true);
        O.setText("-O [TCP/IP fingerprint - OS detect]*");
        O.setOpaque(false);
        O.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                OItemStateChanged(evt);
            }
        });

        PanelCombmode.add(O);

        tab_scanmode.add(PanelCombmode);

        PanelHelp.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 3, 0));

        PanelHelp.setPreferredSize(new java.awt.Dimension(785, 30));
        PanelHelp.setOpaque(false);
        button_oh.setFont(new java.awt.Font("Dialog", 0, 12));
        button_oh.setText("Options Help");
        button_oh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_ohActionPerformed(evt);
            }
        });

        PanelHelp.add(button_oh);

        sep2_smo.setPreferredSize(new java.awt.Dimension(388, 0));
        PanelHelp.add(sep2_smo);

        label_inforoot.setFont(new java.awt.Font("Dialog", 0, 11));
        label_inforoot.setText("  * Only root can use this scan mode & options.");
        PanelHelp.add(label_inforoot);

        tab_scanmode.add(PanelHelp);

        Tabbed.addTab("Scan Mode", null, tab_scanmode, "Scan Mode options for nmap.");

        tab_goptions.setLayout(new java.awt.GridLayout(1, 3));

        tab_goptions.setToolTipText("");
        tab_goptions.setName("General Options");
        tab_goptions.setOpaque(false);
        Panel_C1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 5, 4));

        Panel_C1.setOpaque(false);
        Panel_Pingo.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 3, 15));

        Panel_Pingo.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "Ping Options", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), null));
        Panel_Pingo.setPreferredSize(new java.awt.Dimension(253, 323));
        Panel_Pingo.setOpaque(false);
        P0.setFont(new java.awt.Font("Dialog", 0, 11));
        P0.setText("-P0 [NO ping probe]");
        P0.setOpaque(false);
        P0.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                P0ItemStateChanged(evt);
            }
        });

        Panel_Pingo.add(P0);

        PB.setFont(new java.awt.Font("Dialog", 0, 11));
        PB.setText("-PB [Default ping type]");
        PB.setOpaque(false);
        Panel_Pingo.add(PB);

        PE.setFont(new java.awt.Font("Dialog", 0, 11));
        PE.setText("-PE [Use true ping packet]");
        PE.setOpaque(false);
        Panel_Pingo.add(PE);

        PP.setFont(new java.awt.Font("Dialog", 0, 11));
        PP.setText("-PP [ICMP type13 - Timestamp request]");
        PP.setOpaque(false);
        Panel_Pingo.add(PP);

        PM.setFont(new java.awt.Font("Dialog", 0, 11));
        PM.setText("-PM [ICMP type17 - Netmask request]");
        PM.setOpaque(false);
        Panel_Pingo.add(PM);

        PU.setFont(new java.awt.Font("Dialog", 0, 11));
        PU.setText("-PU [UDP ping]*");
        PU.setOpaque(false);
        PU.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                PUMouseClicked(evt);
            }
        });

        Panel_Pingo.add(PU);

        sep5.setPreferredSize(new java.awt.Dimension(16, 0));
        Panel_Pingo.add(sep5);

        PU_port.setText("[portlist]");
        PU_port.setPreferredSize(new java.awt.Dimension(100, 21));
        PU_port.setEnabled(false);
        Panel_Pingo.add(PU_port);

        PA.setFont(new java.awt.Font("Dialog", 0, 11));
        PA.setText("-PA [TCP ACK ping]");
        PA.setOpaque(false);
        PA.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                PAMouseClicked(evt);
            }
        });

        Panel_Pingo.add(PA);

        PA_port.setText("[portlist]");
        PA_port.setPreferredSize(new java.awt.Dimension(100, 21));
        PA_port.setEnabled(false);
        Panel_Pingo.add(PA_port);

        PS.setFont(new java.awt.Font("Dialog", 0, 11));
        PS.setText("-PS [TCP SYN ping]");
        PS.setOpaque(false);
        PS.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                PSMouseClicked(evt);
            }
        });

        Panel_Pingo.add(PS);

        sep7.setPreferredSize(new java.awt.Dimension(1, 0));
        Panel_Pingo.add(sep7);

        PS_port.setText("[portlist]");
        PS_port.setPreferredSize(new java.awt.Dimension(100, 21));
        PS_port.setEnabled(false);
        Panel_Pingo.add(PS_port);

        Panel_C1.add(Panel_Pingo);

        Panel_DNSo.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 3, 12));

        Panel_DNSo.setBorder(new javax.swing.border.CompoundBorder(null, new javax.swing.border.TitledBorder(null, "Reverse DNS Options", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))));
        Panel_DNSo.setPreferredSize(new java.awt.Dimension(253, 90));
        Panel_DNSo.setRequestFocusEnabled(false);
        Panel_DNSo.setOpaque(false);
        n.setFont(new java.awt.Font("Dialog", 0, 11));
        n.setText("-n [NEVER do reverse DNS resolution]");
        n.setOpaque(false);
        n.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                nItemStateChanged(evt);
            }
        });

        Panel_DNSo.add(n);

        R.setFont(new java.awt.Font("Dialog", 0, 11));
        R.setText("-R [ALWAY do reverse DNS resolution]");
        R.setOpaque(false);
        R.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                RItemStateChanged(evt);
            }
        });

        Panel_DNSo.add(R);

        Panel_C1.add(Panel_DNSo);

        tab_goptions.add(Panel_C1);

        Panel_C2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 5, 4));

        Panel_C2.setOpaque(false);
        Panel_Ports.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 3, 15));

        Panel_Ports.setBorder(new javax.swing.border.CompoundBorder(null, new javax.swing.border.TitledBorder(null, "Ports & Hosts Options", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))));
        Panel_Ports.setPreferredSize(new java.awt.Dimension(253, 323));
        Panel_Ports.setOpaque(false);
        p_all.setFont(new java.awt.Font("Dialog", 0, 11));
        p_all.setText("-p- [Scan all ports]");
        p_all.setOpaque(false);
        p_all.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                p_allItemStateChanged(evt);
            }
        });

        Panel_Ports.add(p_all);

        sep8.setPreferredSize(new java.awt.Dimension(105, 15));
        Panel_Ports.add(sep8);

        p.setFont(new java.awt.Font("Dialog", 0, 11));
        p.setText("-p [Port range]");
        p.setOpaque(false);
        p.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                pItemStateChanged(evt);
            }
        });

        Panel_Ports.add(p);

        p_TCPport.setText("T:");
        p_TCPport.setPreferredSize(new java.awt.Dimension(125, 21));
        p_TCPport.setEnabled(false);
        Panel_Ports.add(p_TCPport);

        sep3.setPreferredSize(new java.awt.Dimension(105, 15));
        Panel_Ports.add(sep3);

        p_UDPport.setText("U:");
        p_UDPport.setPreferredSize(new java.awt.Dimension(125, 21));
        p_UDPport.setEnabled(false);
        Panel_Ports.add(p_UDPport);

        M.setFont(new java.awt.Font("Dialog", 0, 11));
        M.setText("-M [Max Sock] ");
        M.setEnabled(false);
        M.setOpaque(false);
        M.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                MMouseClicked(evt);
            }
        });

        Panel_Ports.add(M);

        M_infos.setText("1024");
        M_infos.setPreferredSize(new java.awt.Dimension(125, 21));
        M_infos.setEnabled(false);
        Panel_Ports.add(M_infos);

        e.setFont(new java.awt.Font("Dialog", 0, 11));
        e.setText("-e [Interfaces] ");
        e.setOpaque(false);
        e.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                eMouseClicked(evt);
            }
        });

        Panel_Ports.add(e);

        e_infos.setText("eth0");
        e_infos.setPreferredSize(new java.awt.Dimension(126, 21));
        e_infos.setEnabled(false);
        Panel_Ports.add(e_infos);

        source_port.setFont(new java.awt.Font("Dialog", 0, 11));
        source_port.setText("--source_port");
        source_port.setOpaque(false);
        source_port.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                source_portMouseClicked(evt);
            }
        });

        Panel_Ports.add(source_port);

        source_port_infos.setText("53,20");
        source_port_infos.setPreferredSize(new java.awt.Dimension(126, 21));
        source_port_infos.setEnabled(false);
        Panel_Ports.add(source_port_infos);

        exclude.setFont(new java.awt.Font("Dialog", 0, 11));
        exclude.setText("--exclude");
        exclude.setOpaque(false);
        exclude.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                excludeMouseClicked(evt);
            }
        });

        Panel_Ports.add(exclude);

        exclude_infos.setText("<host1,host2,..>");
        exclude_infos.setMinimumSize(new java.awt.Dimension(4, 21));
        exclude_infos.setPreferredSize(new java.awt.Dimension(150, 21));
        exclude_infos.setEnabled(false);
        Panel_Ports.add(exclude_infos);

        S.setFont(new java.awt.Font("Dialog", 0, 11));
        S.setText("-S  ");
        S.setOpaque(false);
        S.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                SMouseClicked(evt);
            }
        });

        Panel_Ports.add(S);

        S_infos.setText("<Your IP_Address>");
        S_infos.setPreferredSize(new java.awt.Dimension(187, 21));
        S_infos.setEnabled(false);
        Panel_Ports.add(S_infos);

        Panel_C2.add(Panel_Ports);

        Panel_Verbosity.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 3, 12));

        Panel_Verbosity.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "Verbosity Options", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), null));
        Panel_Verbosity.setPreferredSize(new java.awt.Dimension(253, 90));
        Panel_Verbosity.setOpaque(false);
        v.setFont(new java.awt.Font("Dialog", 0, 11));
        v.setSelected(true);
        v.setText("-v [Verbose nmap mode]");
        v.setOpaque(false);
        Panel_Verbosity.add(v);

        d.setFont(new java.awt.Font("Dialog", 0, 11));
        d.setText("-d [Debug nmap mode]");
        d.setOpaque(false);
        Panel_Verbosity.add(d);

        Panel_C2.add(Panel_Verbosity);

        tab_goptions.add(Panel_C2);

        Panel_C3.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 5, 4));

        Panel_C3.setOpaque(false);
        Panel_Misc.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 3, 15));

        Panel_Misc.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "Misc Options", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), null));
        Panel_Misc.setPreferredSize(new java.awt.Dimension(253, 323));
        Panel_Misc.setOpaque(false);
        F.setFont(new java.awt.Font("Dialog", 0, 11));
        F.setText("-F [Fast scan mode]");
        F.setOpaque(false);
        F.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                FItemStateChanged(evt);
            }
        });

        Panel_Misc.add(F);

        ipv6.setFont(new java.awt.Font("Dialog", 0, 11));
        ipv6.setText("-6 [IPv6 support]");
        ipv6.setEnabled(false);
        ipv6.setOpaque(false);
        Panel_Misc.add(ipv6);

        r.setFont(new java.awt.Font("Dialog", 0, 11));
        r.setText("-r [NOT randomize order ports]");
        r.setOpaque(false);
        Panel_Misc.add(r);

        randomize_hosts.setFont(new java.awt.Font("Dialog", 0, 11));
        randomize_hosts.setText("--randomize_hosts [Slow scan]");
        randomize_hosts.setOpaque(false);
        Panel_Misc.add(randomize_hosts);

        osscan_limit.setFont(new java.awt.Font("Dialog", 0, 11));
        osscan_limit.setText("--osscan_limit [OS probe]");
        osscan_limit.setEnabled(false);
        osscan_limit.setOpaque(false);
        Panel_Misc.add(osscan_limit);

        data_length.setFont(new java.awt.Font("Dialog", 0, 11));
        data_length.setText("--data_length ");
        data_length.setOpaque(false);
        data_length.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                data_lengthMouseClicked(evt);
            }
        });

        Panel_Misc.add(data_length);

        data_length_infos.setText("<Dim. payload>");
        data_length_infos.setPreferredSize(new java.awt.Dimension(126, 21));
        data_length_infos.setEnabled(false);
        Panel_Misc.add(data_length_infos);

        ttl.setFont(new java.awt.Font("Dialog", 0, 11));
        ttl.setText("--ttl [For IPv4]");
        ttl.setOpaque(false);
        ttl.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ttlMouseClicked(evt);
            }
        });

        Panel_Misc.add(ttl);

        ttl_infos.setPreferredSize(new java.awt.Dimension(128, 21));
        ttl_infos.setEnabled(false);
        Panel_Misc.add(ttl_infos);

        iR.setFont(new java.awt.Font("Dialog", 0, 11));
        iR.setText("-iR [Random]");
        iR.setOpaque(false);
        iR.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                iRMouseClicked(evt);
            }
        });

        Panel_Misc.add(iR);

        iR_infos.setText("1 [0 for crazy!]");
        iR_infos.setPreferredSize(new java.awt.Dimension(135, 21));
        iR_infos.setEnabled(false);
        Panel_Misc.add(iR_infos);

        Panel_C3.add(Panel_Misc);

        Panel_Genius.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 3, 12));

        Panel_Genius.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "\"Genius\" Options", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), null));
        Panel_Genius.setPreferredSize(new java.awt.Dimension(253, 90));
        Panel_Genius.setOpaque(false);
        D.setFont(new java.awt.Font("Dialog", 0, 11));
        D.setText("-D*");
        D.setOpaque(false);
        D.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                DMouseClicked(evt);
            }
        });

        Panel_Genius.add(D);

        D_infos.setText("<decoy1,decoy2,ME,...>");
        D_infos.setPreferredSize(new java.awt.Dimension(186, 21));
        D_infos.setEnabled(false);
        Panel_Genius.add(D_infos);

        f.setFont(new java.awt.Font("Dialog", 0, 11));
        f.setText("-f [fregmented IP packets]*");
        f.setOpaque(false);
        Panel_Genius.add(f);

        Panel_C3.add(Panel_Genius);

        tab_goptions.add(Panel_C3);

        Tabbed.addTab("General Options", null, tab_goptions, "General options for nmap.");

        tab_timing.setLayout(new java.awt.GridLayout(1, 2));

        tab_timing.setToolTipText("");
        tab_timing.setName("Timing Options");
        tab_timing.setOpaque(false);
        Panel_T1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 5, 14));

        Panel_T1.setOpaque(false);
        Panel_Thrott.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 4, 13));

        Panel_Thrott.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "Throtting Options", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), null));
        Panel_Thrott.setPreferredSize(new java.awt.Dimension(385, 70));
        Panel_Thrott.setOpaque(false);
        T.setFont(new java.awt.Font("Dialog", 0, 11));
        T.setText("-T");
        T.setOpaque(false);
        Panel_Thrott.add(T);

        T_cbox.setFont(new java.awt.Font("Dialog", 0, 12));
        T_cbox.setPreferredSize(new java.awt.Dimension(113, 24));
        T_cbox.setOpaque(false);
        Panel_Thrott.add(T_cbox);

        info_crash.setFont(new java.awt.Font("Dialog", 0, 11));
        info_crash.setText(" High chances of crashing: ");
        Panel_Thrott.add(info_crash);

        button_helpT.setFont(new java.awt.Font("Dialog", 0, 11));
        button_helpT.setText("Help");
        button_helpT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_helpTActionPerformed(evt);
            }
        });

        Panel_Thrott.add(button_helpT);

        Panel_T1.add(Panel_Thrott);

        Panel_TDO.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 4, 26));

        Panel_TDO.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "Timeout & Delay Options", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), null));
        Panel_TDO.setPreferredSize(new java.awt.Dimension(385, 317));
        Panel_TDO.setOpaque(false);
        initial_rtt_to.setFont(new java.awt.Font("Dialog", 0, 11));
        initial_rtt_to.setText("--initial_rtt_timeout [An initial probe timeout]");
        initial_rtt_to.setEnabled(false);
        initial_rtt_to.setOpaque(false);
        initial_rtt_to.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                initial_rtt_toMouseClicked(evt);
            }
        });

        Panel_TDO.add(initial_rtt_to);

        sep11.setPreferredSize(new java.awt.Dimension(6, 0));
        Panel_TDO.add(sep11);

        initial_rtt_to_ms.setText("6000");
        initial_rtt_to_ms.setPreferredSize(new java.awt.Dimension(65, 21));
        initial_rtt_to_ms.setEnabled(false);
        Panel_TDO.add(initial_rtt_to_ms);

        ms.setFont(new java.awt.Font("Dialog", 0, 11));
        ms.setText("ms");
        Panel_TDO.add(ms);

        host_timeout.setFont(new java.awt.Font("Dialog", 0, 11));
        host_timeout.setText("--host_timeout [Time spending for single host]");
        host_timeout.setOpaque(false);
        host_timeout.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                host_timeoutMouseClicked(evt);
            }
        });

        Panel_TDO.add(host_timeout);

        host_timeout_ms.setText("6000");
        host_timeout_ms.setPreferredSize(new java.awt.Dimension(65, 21));
        host_timeout_ms.setEnabled(false);
        Panel_TDO.add(host_timeout_ms);

        ms6.setFont(new java.awt.Font("Dialog", 0, 11));
        ms6.setText("ms");
        Panel_TDO.add(ms6);

        max_rtt_to.setFont(new java.awt.Font("Dialog", 0, 11));
        max_rtt_to.setText("--max_rtt_timeout [Wait for a probe response]");
        max_rtt_to.setOpaque(false);
        max_rtt_to.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                max_rtt_toMouseClicked(evt);
            }
        });

        Panel_TDO.add(max_rtt_to);

        Panel_TDO.add(sep2);

        max_rtt_to_ms.setText("6000");
        max_rtt_to_ms.setPreferredSize(new java.awt.Dimension(65, 21));
        max_rtt_to_ms.setEnabled(false);
        Panel_TDO.add(max_rtt_to_ms);

        ms1.setFont(new java.awt.Font("Dialog", 0, 11));
        ms1.setText("ms");
        Panel_TDO.add(ms1);

        min_rtt_to.setFont(new java.awt.Font("Dialog", 0, 11));
        min_rtt_to.setText("--min_rtt_timeout [Wait between probe-probe]");
        min_rtt_to.setOpaque(false);
        min_rtt_to.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                min_rtt_toMouseClicked(evt);
            }
        });

        Panel_TDO.add(min_rtt_to);

        Panel_TDO.add(sep4);

        min_rtt_to_ms.setText("6000");
        min_rtt_to_ms.setPreferredSize(new java.awt.Dimension(65, 21));
        min_rtt_to_ms.setEnabled(false);
        Panel_TDO.add(min_rtt_to_ms);

        ms2.setFont(new java.awt.Font("Dialog", 0, 11));
        ms2.setText("ms");
        Panel_TDO.add(ms2);

        min_sd.setFont(new java.awt.Font("Dialog", 0, 11));
        min_sd.setText("--min_scan_delay [Time wait between probes] ");
        min_sd.setOpaque(false);
        min_sd.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                min_sdMouseClicked(evt);
            }
        });

        Panel_TDO.add(min_sd);

        sep6.setPreferredSize(new java.awt.Dimension(1, 0));
        Panel_TDO.add(sep6);

        min_sd_s.setText("6000");
        min_sd_s.setPreferredSize(new java.awt.Dimension(65, 21));
        min_sd_s.setEnabled(false);
        Panel_TDO.add(min_sd_s);

        ms5.setFont(new java.awt.Font("Dialog", 0, 11));
        ms5.setText("ms");
        Panel_TDO.add(ms5);

        max_sd.setFont(new java.awt.Font("Dialog", 0, 11));
        max_sd.setText("--max_scan_delay [Time wait between probes]");
        max_sd.setOpaque(false);
        max_sd.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                max_sdMouseClicked(evt);
            }
        });

        Panel_TDO.add(max_sd);

        sep9.setPreferredSize(new java.awt.Dimension(1, 0));
        Panel_TDO.add(sep9);

        max_sd_s.setText("6000");
        max_sd_s.setPreferredSize(new java.awt.Dimension(65, 21));
        max_sd_s.setEnabled(false);
        Panel_TDO.add(max_sd_s);

        ms7.setFont(new java.awt.Font("Dialog", 0, 11));
        ms7.setText("ms");
        Panel_TDO.add(ms7);

        Panel_T1.add(Panel_TDO);

        tab_timing.add(Panel_T1);

        Panel_T2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 5, 12));

        Panel_T2.setOpaque(false);
        Panel_Parallel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 6, 25));

        Panel_Parallel.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "Parallelism Options", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), null));
        Panel_Parallel.setPreferredSize(new java.awt.Dimension(385, 218));
        Panel_Parallel.setOpaque(false);
        max_par.setFont(new java.awt.Font("Dialog", 0, 11));
        max_par.setText("--max_parallelism [Max number of port scanned]");
        max_par.setOpaque(false);
        max_par.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                max_parMouseClicked(evt);
            }
        });

        Panel_Parallel.add(max_par);

        max_par_n.setText("1");
        max_par_n.setPreferredSize(new java.awt.Dimension(67, 21));
        max_par_n.setEnabled(false);
        Panel_Parallel.add(max_par_n);

        min_par.setFont(new java.awt.Font("Dialog", 0, 11));
        min_par.setText("--min_parallelism [Min number of port scanned]");
        min_par.setOpaque(false);
        min_par.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                min_parMouseClicked(evt);
            }
        });

        Panel_Parallel.add(min_par);

        sep10.setPreferredSize(new java.awt.Dimension(1, 0));
        Panel_Parallel.add(sep10);

        min_par_n.setText("1");
        min_par_n.setPreferredSize(new java.awt.Dimension(67, 21));
        min_par_n.setEnabled(false);
        Panel_Parallel.add(min_par_n);

        max_hostgroup.setFont(new java.awt.Font("Dialog", 0, 11));
        max_hostgroup.setText("--max_hostgroup [Max host number scan parallel]");
        max_hostgroup.setOpaque(false);
        max_hostgroup.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                max_hostgroupMouseClicked(evt);
            }
        });

        Panel_Parallel.add(max_hostgroup);

        max_hostgroup_infos.setText("50");
        max_hostgroup_infos.setPreferredSize(new java.awt.Dimension(60, 21));
        max_hostgroup_infos.setEnabled(false);
        Panel_Parallel.add(max_hostgroup_infos);

        min_hostgroup.setFont(new java.awt.Font("Dialog", 0, 11));
        min_hostgroup.setText("--min_hostgroup [Min host number scan parallel]  ");
        min_hostgroup.setOpaque(false);
        min_hostgroup.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                min_hostgroupMouseClicked(evt);
            }
        });

        Panel_Parallel.add(min_hostgroup);

        min_hostgroup_infos.setText("50");
        min_hostgroup_infos.setPreferredSize(new java.awt.Dimension(60, 21));
        min_hostgroup_infos.setEnabled(false);
        Panel_Parallel.add(min_hostgroup_infos);

        Panel_T2.add(Panel_Parallel);

        tab_timing.add(Panel_T2);

        Tabbed.addTab("Timing Options", null, tab_timing, "Timing options for nmap.");

        tab_specials.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 5, 15));

        tab_specials.setOpaque(false);
        Panel_space.setLayout(new java.awt.GridLayout(5, 1, 0, 15));

        Panel_space.setPreferredSize(new java.awt.Dimension(760, 400));
        Panel_space.setOpaque(false);
        Panel_oX.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 10, 10));

        Panel_oX.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "oX - Save Logs in XML format.", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), new javax.swing.border.EtchedBorder()));
        Panel_oX.setOpaque(false);
        oX.setFont(new java.awt.Font("Dialog", 0, 11));
        oX.setText("-oX");
        oX.setOpaque(false);
        oX.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                oXMouseClicked(evt);
            }
        });

        Panel_oX.add(oX);

        label_path.setFont(new java.awt.Font("Dialog", 0, 11));
        label_path.setText("Path logs file:");
        Panel_oX.add(label_path);

        text_path.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        text_path.setPreferredSize(new java.awt.Dimension(400, 21));
        text_path.setEnabled(false);
        Panel_oX.add(text_path);

        select_button.setFont(new java.awt.Font("Dialog", 0, 12));
        select_button.setText("Select logs");
        select_button.setEnabled(false);
        select_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                select_buttonActionPerformed(evt);
            }
        });

        Panel_oX.add(select_button);

        Panel_space.add(Panel_oX);

        Panel_oG.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 10, 10));

        Panel_oG.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "oG - Save Logs in grepable format.", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), new javax.swing.border.EtchedBorder()));
        Panel_oG.setOpaque(false);
        oG.setFont(new java.awt.Font("Dialog", 0, 11));
        oG.setText("-oG");
        oG.setOpaque(false);
        oG.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                oGMouseClicked(evt);
            }
        });

        Panel_oG.add(oG);

        label_path1.setFont(new java.awt.Font("Dialog", 0, 11));
        label_path1.setText("Path logs file:");
        Panel_oG.add(label_path1);

        text_path1.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        text_path1.setPreferredSize(new java.awt.Dimension(400, 21));
        text_path1.setEnabled(false);
        Panel_oG.add(text_path1);

        select_button1.setFont(new java.awt.Font("Dialog", 0, 12));
        select_button1.setText("Select logs");
        select_button1.setEnabled(false);
        select_button1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                select_button1ActionPerformed(evt);
            }
        });

        Panel_oG.add(select_button1);

        Panel_space.add(Panel_oG);

        Panel_oS.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 10, 10));

        Panel_oS.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "oS - Save Logs in s|<ipT kiDd|3 format.", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), new javax.swing.border.EtchedBorder()));
        Panel_oS.setOpaque(false);
        oS.setFont(new java.awt.Font("Dialog", 0, 11));
        oS.setText("-oS");
        oS.setOpaque(false);
        oS.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                oSMouseClicked(evt);
            }
        });

        Panel_oS.add(oS);

        label_path3.setFont(new java.awt.Font("Dialog", 0, 11));
        label_path3.setText("Path logs file:");
        Panel_oS.add(label_path3);

        text_path3.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        text_path3.setPreferredSize(new java.awt.Dimension(400, 21));
        text_path3.setEnabled(false);
        Panel_oS.add(text_path3);

        select_button3.setFont(new java.awt.Font("Dialog", 0, 12));
        select_button3.setText("Select logs");
        select_button3.setEnabled(false);
        select_button3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                select_button3ActionPerformed(evt);
            }
        });

        Panel_oS.add(select_button3);

        Panel_space.add(Panel_oS);

        Panel_oA.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 10, 10));

        Panel_oA.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "oA - Save Logs in all major formats.", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), new javax.swing.border.EtchedBorder()));
        Panel_oA.setOpaque(false);
        oA.setFont(new java.awt.Font("Dialog", 0, 11));
        oA.setText("-oA");
        oA.setOpaque(false);
        oA.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                oAMouseClicked(evt);
            }
        });

        Panel_oA.add(oA);

        label_path2.setFont(new java.awt.Font("Dialog", 0, 11));
        label_path2.setText("Path logs file:");
        Panel_oA.add(label_path2);

        text_path2.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        text_path2.setPreferredSize(new java.awt.Dimension(400, 21));
        text_path2.setEnabled(false);
        Panel_oA.add(text_path2);

        select_button2.setFont(new java.awt.Font("Dialog", 0, 12));
        select_button2.setText("Select logs");
        select_button2.setEnabled(false);
        select_button2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                select_button2ActionPerformed(evt);
            }
        });

        Panel_oA.add(select_button2);

        Panel_space.add(Panel_oA);

        Panel_iL.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 14, 10));

        Panel_iL.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "iL - Reads target specifications from file.", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), new javax.swing.border.EtchedBorder()));
        Panel_iL.setOpaque(false);
        iL.setFont(new java.awt.Font("Dialog", 0, 11));
        iL.setText("-iL");
        iL.setOpaque(false);
        iL.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                iLMouseClicked(evt);
            }
        });

        Panel_iL.add(iL);

        label_path4.setFont(new java.awt.Font("Dialog", 0, 11));
        label_path4.setText("Path list file:");
        Panel_iL.add(label_path4);

        text_path4.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        text_path4.setPreferredSize(new java.awt.Dimension(400, 21));
        text_path4.setEnabled(false);
        Panel_iL.add(text_path4);

        select_button4.setFont(new java.awt.Font("Dialog", 0, 12));
        select_button4.setText("Select list");
        select_button4.setEnabled(false);
        select_button4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                select_button4ActionPerformed(evt);
            }
        });

        Panel_iL.add(select_button4);

        Panel_space.add(Panel_iL);

        tab_specials.add(Panel_space);

        Tabbed.addTab("Files Options", null, tab_specials, "Files options for nmap logs.");

        tab_running.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 5, 6));

        tab_running.setToolTipText("");
        tab_running.setName("");
        tab_running.setOpaque(false);
        Panel_ErrIm.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 15, 11));

        Panel_ErrIm.setPreferredSize(new java.awt.Dimension(780, 205));
        Panel_ErrIm.setOpaque(false);
        iconscan.setIcon(new javax.swing.ImageIcon(getClass().getResource("/img/noscan.gif")));
        Panel_ErrIm.add(iconscan);

        Scroll_error.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "<Nmap Error>", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), new javax.swing.border.EtchedBorder()));
        Scroll_error.setPreferredSize(new java.awt.Dimension(468, 190));
        Scroll_error.setOpaque(false);
        text_errorsr.setFont(new java.awt.Font("Dialog", 0, 11));
        text_errorsr.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        text_errorsr.setEnabled(false);
        Scroll_error.setViewportView(text_errorsr);

        Panel_ErrIm.add(Scroll_error);

        tab_running.add(Panel_ErrIm);

        Panel_RSS.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 6));

        Panel_RSS.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder(null, "<Summary Nmap Scan>", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10)), null));
        Panel_RSS.setPreferredSize(new java.awt.Dimension(767, 192));
        Panel_RSS.setOpaque(false);
        Panel_RSS1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 5, 10));

        Panel_RSS1.setPreferredSize(new java.awt.Dimension(735, 36));
        Panel_RSS1.setOpaque(false);
        label_ht.setFont(new java.awt.Font("Monospaced", 1, 11));
        label_ht.setText("Host(s) Target...:");
        Panel_RSS1.add(label_ht);

        label_cht.setFont(new java.awt.Font("Dialog", 0, 11));
        label_cht.setText("localhost");
        Panel_RSS1.add(label_cht);

        Panel_RSS.add(Panel_RSS1);

        Panel_RSS2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 5, 10));

        Panel_RSS2.setPreferredSize(new java.awt.Dimension(735, 36));
        Panel_RSS2.setOpaque(false);
        label_cn.setFont(new java.awt.Font("Monospaced", 1, 11));
        label_cn.setText("Nmap Command.....:");
        Panel_RSS2.add(label_cn);

        label_cnmap.setFont(new java.awt.Font("Dialog", 0, 11));
        label_cnmap.setText("Nmap not running.");
        label_cnmap.setPreferredSize(new java.awt.Dimension(595, 15));
        label_cnmap.setAutoscrolls(true);
        Panel_RSS2.add(label_cnmap);

        Panel_RSS.add(Panel_RSS2);

        Panel_RSS3.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 5, 10));

        Panel_RSS3.setPreferredSize(new java.awt.Dimension(735, 36));
        Panel_RSS3.setOpaque(false);
        label_ssi.setFont(new java.awt.Font("Monospaced", 1, 11));
        label_ssi.setText("Time Scan info...:");
        Panel_RSS3.add(label_ssi);

        label_ssc.setFont(new java.awt.Font("Dialog", 0, 11));
        label_ssc.setText("No Infos.");
        Panel_RSS3.add(label_ssc);

        Panel_RSS.add(Panel_RSS3);

        Panel_RSS4.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 5, 10));

        Panel_RSS4.setPreferredSize(new java.awt.Dimension(735, 36));
        Panel_RSS4.setOpaque(false);
        label_ss.setFont(new java.awt.Font("Monospaced", 1, 11));
        label_ss.setText("Status Scan......:");
        Panel_RSS4.add(label_ss);

        label_ssrt.setFont(new java.awt.Font("Dialog", 0, 11));
        label_ssrt.setText("Any Scan Started!");
        Panel_RSS4.add(label_ssrt);

        Panel_RSS.add(Panel_RSS4);

        tab_running.add(Panel_RSS);

        Tabbed.addTab("Scanning run...", null, tab_running, "Running Scan...");

        tab_scan.setToolTipText("");
        tab_scan.setOpaque(false);
        Scrolltextres.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder("<Nmap Result>"), new javax.swing.border.EtchedBorder()));
        Scrolltextres.setToolTipText("");
        Scrolltextres.setPreferredSize(new java.awt.Dimension(780, 382));
        Scrolltextres.setOpaque(false);
        textresult.setFont(new java.awt.Font("Monospaced", 0, 11));
        textresult.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 4, 0, 0)));
        textresult.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        textresult.setVerifyInputWhenFocusTarget(false);
        textresult.setEnabled(false);
        Scrolltextres.setViewportView(textresult);

        tab_scan.add(Scrolltextres);

        Panelresults.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 0, 4));

        Panelresults.setPreferredSize(new java.awt.Dimension(768, 30));
        Panelresults.setOpaque(false);
        button_saveres.setFont(new java.awt.Font("Dialog", 0, 12));
        button_saveres.setText("Save Results");
        button_saveres.setToolTipText("");
        button_saveres.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_saveresActionPerformed(evt);
            }
        });

        Panelresults.add(button_saveres);

        label_sepsr.setPreferredSize(new java.awt.Dimension(10, 15));
        Panelresults.add(label_sepsr);

        button_reset.setFont(new java.awt.Font("Dialog", 0, 12));
        button_reset.setText("Reset");
        button_reset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_resetActionPerformed(evt);
            }
        });

        Panelresults.add(button_reset);

        tab_scan.add(Panelresults);

        Tabbed.addTab("Scan Result!", null, tab_scan, "Scan result window.");

        tab_credits.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 30));

        tab_credits.setToolTipText("");
        tab_credits.setOpaque(false);
        label_logo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/img/jnmap-logo.gif")));
        label_logo.setBorder(new javax.swing.border.EtchedBorder());
        tab_credits.add(label_logo);

        Panel_credits.setLayout(new java.awt.GridLayout(3, 0));

        Panel_credits.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.EtchedBorder(javax.swing.border.EtchedBorder.RAISED), new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 1, 1, 1))));
        Panel_credits.setPreferredSize(new java.awt.Dimension(750, 255));
        Panel_credits.setEnabled(false);
        Panel_credits.setOpaque(false);
        Text_credits1.setFont(new java.awt.Font("Dialog", 1, 12));
        Text_credits1.setText("\t\t\t          \n\t\t                       ...::::   J[Nmap] - Ver. 3.81   ::::...\n\n\t               \t               Powered By nEcR0SoFt [Dario Maggiari]");
        Text_credits1.setBorder(null);
        Text_credits1.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        Text_credits1.setPreferredSize(new java.awt.Dimension(748, 233));
        Text_credits1.setEnabled(false);
        Panel_credits.add(Text_credits1);

        Text_credits2.setFont(new java.awt.Font("Dialog", 0, 11));
        Text_credits2.setText("\t                 J[Nmap] is a front-end for Nmap Security Scanner writted in Java with javax.Swing and AWT. \n\n\t\t                    J[Nmap] is OpenSource and distributed under GPL license.");
        Text_credits2.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        Text_credits2.setEnabled(false);
        Panel_credits.add(Text_credits2);

        Text_credits3.setFont(new java.awt.Font("Dialog", 0, 11));
        Text_credits3.setText("   J[Nmap] Project Page: http://necrosoft.altervista.org/jnmap.html     \n\n   Nmap Project: http://www.insecure.org/nmap/     \n\n   Mail To: necrosoft@slacky.it\t\t\t\t\t\t\tnEcR0SoFt [2005]");
        Text_credits3.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        Text_credits3.setPreferredSize(new java.awt.Dimension(739, 89));
        Text_credits3.setEnabled(false);
        Panel_credits.add(Text_credits3);

        tab_credits.add(Panel_credits);

        Tabbed.addTab("Credits", null, tab_credits, "Credits J[Nmap]");

        Globalpane.add(Tabbed);

        Startpane.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 0, 12));

        Startpane.setPreferredSize(new java.awt.Dimension(790, 40));
        button_kill.setFont(new java.awt.Font("Dialog", 0, 12));
        button_kill.setText("Kill Scan!");
        button_kill.setPreferredSize(new java.awt.Dimension(89, 25));
        button_kill.setEnabled(false);
        button_kill.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_killActionPerformed(evt);
            }
        });

        Startpane.add(button_kill);

        label_separator1.setFont(new java.awt.Font("Dialog", 0, 12));
        label_separator1.setText(" ");
        label_separator1.setPreferredSize(new java.awt.Dimension(60, 15));
        Startpane.add(label_separator1);

        labelip.setText("Host(s) Target : ");
        Startpane.add(labelip);

        textip.setText("localhost");
        textip.setDisabledTextColor(new java.awt.Color(204, 204, 204));
        textip.setPreferredSize(new java.awt.Dimension(383, 21));
        Startpane.add(textip);

        label_separator.setFont(new java.awt.Font("Dialog", 0, 12));
        label_separator.setText(" ");
        label_separator.setPreferredSize(new java.awt.Dimension(60, 15));
        Startpane.add(label_separator);

        button_scan.setText("Start Scan!");
        button_scan.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_scanActionPerformed(evt);
            }
        });

        Startpane.add(button_scan);

        Globalpane.add(Startpane);

        getContentPane().add(Globalpane);

        pack();
    }//GEN-END:initComponents
    
    /**
      Intercettatore del bottone "kill scan!" per la terminazione del processo nmap.
      @param evt Un ActionEvent.     
     */
    private void button_killActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_killActionPerformed
       Runtime run = Runtime.getRuntime();
       
       try { run.exec("killall -9 nmap"); }
       
       catch (IOException e) {}
    }//GEN-LAST:event_button_killActionPerformed
    
    /** 
      Intercettatore del bottone "Start scan!". Il metodo lancia un thread che si fa carico di chiamare "nmap" 
      settando i corretti parametri in base alle scelte dell'utente effettuate dal front-end.
      @param evt Un ActionEvent.
     */    
    private void button_scanActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_scanActionPerformed
       if(!((textip.getText()).equalsIgnoreCase("")) || (iL.isSelected() && !text_path4.getText().equalsIgnoreCase("")))
           {
            button_kill.setEnabled(true);   
            button_scan.setEnabled(false);
            iconscan.setIcon(new javax.swing.ImageIcon(getClass().getResource("/img/yscan.gif"))); //Abilita gif animata.
            Tabbed.setEnabled(false);
            textip.setEditable(false);

            command_nmap = "nmap" + bScanModeOptions() + bSMOptions() + bGeneralOptions() + bTimingOptions() + specialFileOptions() + " " + textip.getText();    
            
            if(!iL.isSelected()) { label_cht.setText(textip.getText()); }
            
            else { label_cht.setText("Read Target(s) from file..."); }
                
            label_cnmap.setText(command_nmap);
                  
            if(!iL.isSelected()) 
              { 
               setTitle("J[Nmap] - Scan [ " + textip.getText() + " ] running . . . Please wait!");   
               label_ssrt.setText("Scan [ " + textip.getText() + " ] running . . . Please wait!"); 
              }
            
            else 
               { 
                setTitle("J[Nmap] - Scan [ Target(s) from File ] running . . . Please wait!");   
                label_ssrt.setText("Scan [ Target(s) from File ] running . . . Please wait! -- [Ignoring 'Host(s) Target' space.]"); 
               }
            
            Tabbed.setSelectedComponent(tab_running);

            Runtime run = Runtime.getRuntime(); //Ottiene il processo per la gestione dei comandi.
            
            Date date = new Date();
            String data = date.toString();
            label_ssc.setText("Start: " + data);

            JnmapThread jnmthread = new JnmapThread(command_nmap, run, this);
            jnmthread.start();
           }
        
        else
           {
            command_nmap = "nmap" + bScanModeOptions() + bSMOptions() + bGeneralOptions() + bTimingOptions() + specialFileOptions() + " " + textip.getText();   
            text_errorsr.append("COMMAND LAUNCHED: [ " + command_nmap + " ]\n");   
            
            if(!iL.isSelected()) { text_errorsr.append("Nmap can't start: please insert 'Host(s) Target' or select 'iL' Option.\n\n"); }
                  
            else { text_errorsr.append("Nmap can't start: If you check 'iL' Option you must select a file!\n\n"); }
            
            label_cnmap.setText(command_nmap);
            label_ssrt.setText("Error launching Nmap!");
            label_cht.setText("No Target.");
            label_ssc.setText("Start: " + new Date());
            setTitle("J[Nmap] - REPORT: Error launching Nmap!");

            Tabbed.setSelectedComponent(tab_running);
            labelip.transferFocus();
           }
    }//GEN-LAST:event_button_scanActionPerformed
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void pItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_pItemStateChanged
        if(p.isSelected()) 
          { 
           p_TCPport.setEnabled(true);
           p_UDPport.setEnabled(true);
           p.transferFocus(); 
           p_TCPport.select(2,2);
           p_all.setSelected(false);
           p_all.setEnabled(false);
           F.setEnabled(false);
          }
        
        else 
           { 
            p_TCPport.setEnabled(false); 
            p_UDPport.setEnabled(false); 
            p_all.setEnabled(true);
            
            if(!(sL.isSelected() || sP.isSelected())) { F.setEnabled(true); }
           }
    }//GEN-LAST:event_pItemStateChanged
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void p_allItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_p_allItemStateChanged
        if(p_all.isSelected())
          {
           p.setSelected(false);   
           p.setEnabled(false);   
           F.setEnabled(false);
          }
        
        else 
           { 
            p.setEnabled(true); 
            
            if(!(sL.isSelected() || sP.isSelected())) { F.setEnabled(true); }
           }
    }//GEN-LAST:event_p_allItemStateChanged
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void FItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_FItemStateChanged
       if(F.isSelected()) 
         { 
          p_all.setSelected(false);
          p_all.setEnabled(false);
          p.setSelected(false);
          p.setEnabled(false);
         }
       
       else { p_all.setEnabled(true); p.setEnabled(true); }    
    }//GEN-LAST:event_FItemStateChanged
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un MouseEvent.
    */
    private void iLMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_iLMouseClicked
        if(!iL.isSelected()) { text_path4.setText(""); select_button4.setEnabled(false); }
        
        else { select_button4.setEnabled(true); }
    }//GEN-LAST:event_iLMouseClicked
    
    /** 
      Metodo utilizzato per selezionare il file da cui leggere i targets per la scansione.
      @param evt Un ActionEventt.
    */
    private void select_button4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_select_button4ActionPerformed
        FileChooser.addChoosableFileFilter(new TxtFileFilter());
        
        if(FileChooser.showOpenDialog(null) == FileChooser.APPROVE_OPTION)
         {
          File file_f = FileChooser.getSelectedFile(); //File selezionato.
             
          text_path4.setText(file_f.getAbsolutePath()); 
          s_iL = file_f.getAbsolutePath();
         }
    }//GEN-LAST:event_select_button4ActionPerformed
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void bItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_bItemStateChanged
       if(b.isSelected()) 
         { 
          f.setSelected(false);
          f.setEnabled(false);
          D.setSelected(false);
          D.setEnabled(false);
          D_infos.setText("<decoy1,decoy2,ME,...>");
          D_infos.setEnabled(false);
          tfield_b.setEnabled(true);
         }
          
       else 
          { 
           tfield_b.setEnabled(false);   
              
           if(!sT.isSelected()) { D.setEnabled(true); }  
           
           if(!(sI.isSelected() || sO.isSelected() || sT.isSelected() || sU.isSelected() || sL.isSelected() || sP.isSelected())) { f.setEnabled(true); }
          }  
    }//GEN-LAST:event_bItemStateChanged
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void sIItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_sIItemStateChanged
       if(sI.isSelected()) 
         { 
          f.setSelected(false);
          f.setEnabled(false);
          tfield_sI.setEnabled(true);
         }
       
       else
          {
           tfield_sI.setEnabled(false);   
              
           if(!(b.isSelected() || sO.isSelected() || sT.isSelected() || sU.isSelected() || sL.isSelected() || sP.isSelected())) { f.setEnabled(true); }
          }
    }//GEN-LAST:event_sIItemStateChanged
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void RItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_RItemStateChanged
       if(R.isSelected()) { n.setSelected(false); n.setEnabled(false); }
       
       else { n.setEnabled(true); }
    }//GEN-LAST:event_RItemStateChanged
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void nItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_nItemStateChanged
       if(n.isSelected()) { R.setSelected(false); R.setEnabled(false); }
       
       else { R.setEnabled(true); }
    }//GEN-LAST:event_nItemStateChanged
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void sOItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_sOItemStateChanged
       if(sO.isSelected())
         {
          sR.setSelected(false);
          sR.setEnabled(false);
          sV.setSelected(false);
          sV.setEnabled(false);
          sU.setSelected(false);
          sU.setEnabled(false);
          f.setSelected(false);
          f.setEnabled(false);
         }
       
       else
          {
           if(!sL.isSelected() && !sP.isSelected()) { sU.setEnabled(true); }   
              
           if(!sL.isSelected() || !sP.isSelected()) { sR.setEnabled(true); }   
           
           if(!(sL.isSelected() || sT.isSelected() || sP.isSelected() || sU.isSelected() || b.isSelected() || sI.isSelected())) { f.setEnabled(true); }
          }
    }//GEN-LAST:event_sOItemStateChanged
 
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void OItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_OItemStateChanged
        if(O.isSelected())
         {
          osscan_limit.setEnabled(true);
          sP.setEnabled(false);
          sL.setEnabled(false);
         }
       
       else
          {
           osscan_limit.setSelected(false);  
           osscan_limit.setEnabled(false);
           
           if(!sU.isSelected()) { sP.setEnabled(true); sL.setEnabled(true); }
          }
    }//GEN-LAST:event_OItemStateChanged
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un MouseEvent.
    */
    private void oSMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_oSMouseClicked
        if(!oS.isSelected()) { text_path3.setText(""); select_button3.setEnabled(false); }
        
        else { select_button3.setEnabled(true); }
    }//GEN-LAST:event_oSMouseClicked

    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un MouseEvent.
    */
    private void oAMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_oAMouseClicked
        if(!oA.isSelected()) { text_path2.setText(""); select_button2.setEnabled(false); }
        
        else { select_button2.setEnabled(true); }
    }//GEN-LAST:event_oAMouseClicked
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un MouseEvent.
    */
    private void oGMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_oGMouseClicked
        if(!oG.isSelected()) { text_path1.setText(""); select_button1.setEnabled(false); }
        
        else { select_button1.setEnabled(true); }
    }//GEN-LAST:event_oGMouseClicked
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un MouseEvent.
    */
    private void oXMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_oXMouseClicked
        if(!oX.isSelected()) { text_path.setText(""); select_button.setEnabled(false); }
        
        else { select_button.setEnabled(true); }
    }//GEN-LAST:event_oXMouseClicked
    
    /** 
      Metodo utilizzato per selezionare il file in cui salvare i rusultati di nmap.
      @param evt Un ActionEventt.
    */
    private void select_button3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_select_button3ActionPerformed
        FileChooser.addChoosableFileFilter(new TxtFileFilter());
        
        if(FileChooser.showOpenDialog(null) == FileChooser.APPROVE_OPTION)
         {
          File file_f = FileChooser.getSelectedFile(); //File selezionato.
             
          text_path3.setText(file_f.getAbsolutePath()); 
          s_oS = file_f.getAbsolutePath();
         }
    }//GEN-LAST:event_select_button3ActionPerformed
    
    /** 
      Metodo utilizzato per selezionare il file in cui salvare i rusultati di nmap.
      @param evt Un ActionEventt.
    */
    private void select_button2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_select_button2ActionPerformed
        FileChooser.addChoosableFileFilter(new allFileFilter());
        
        if(FileChooser.showOpenDialog(null) == FileChooser.APPROVE_OPTION)
         {
          File file_f = FileChooser.getSelectedFile(); //File selezionato.
             
          text_path2.setText(file_f.getAbsolutePath()); 
          s_oA = file_f.getAbsolutePath();
         }
    }//GEN-LAST:event_select_button2ActionPerformed
    
    /** 
      Metodo utilizzato per selezionare il file in cui salvare i rusultati di nmap.
      @param evt Un ActionEventt.
    */
    private void select_button1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_select_button1ActionPerformed
        FileChooser.addChoosableFileFilter(new grepFileFilter());
        
        if(FileChooser.showOpenDialog(null) == FileChooser.APPROVE_OPTION)
         {
          File file_f = FileChooser.getSelectedFile(); //File selezionato.
             
          text_path1.setText(file_f.getAbsolutePath()); 
          s_oG = file_f.getAbsolutePath();
         }
    }//GEN-LAST:event_select_button1ActionPerformed
    
    /** 
      Metodo utilizzato per selezionare il file in cui salvare i rusultati di nmap.
      @param evt Un ActionEventt.
    */
    private void select_buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_select_buttonActionPerformed
        FileChooser.addChoosableFileFilter(new XMLFileFilter());
        
        if(FileChooser.showOpenDialog(null) == FileChooser.APPROVE_OPTION)
         {
          File file_f = FileChooser.getSelectedFile(); //File selezionato.
             
          text_path.setText(file_f.getAbsolutePath()); 
          s_oX = file_f.getAbsolutePath();
         }
    }//GEN-LAST:event_select_buttonActionPerformed
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void sRItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_sRItemStateChanged
       if(sR.isSelected())
          {
           if(sT.isSelected() || sL.isSelected() || sP.isSelected()) { ipv6.setSelected(false); ipv6.setEnabled(false); }
          }
        
        else
            { 
             if((sT.isSelected() || sL.isSelected() || sP.isSelected()) && !sU.isSelected()) { ipv6.setEnabled(true); }
            }       
    }//GEN-LAST:event_sRItemStateChanged
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void sTItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_sTItemStateChanged
       if(sT.isSelected())
         {
          M.setEnabled(true);
          ipv6.setEnabled(true); //Nmap 3.81 supporta questa opzione solo per sT, sL, sP Scan Mode.
          f.setSelected(false);
          f.setEnabled(false);
          D.setSelected(false);
          D.setEnabled(false);
          D_infos.setText("<decoy1,decoy2,ME,...>");
          D_infos.setEnabled(false);
          
          if(sU.isSelected() || sR.isSelected()) { ipv6.setSelected(false); ipv6.setEnabled(false); }
         }
       
       else
           {
            M.setSelected(false);
            M.setEnabled(false);
            M_infos.setText("1024");
            M_infos.setEnabled(false);
            D.setEnabled(true);
            
            if(!(sL.isSelected() || sP.isSelected() || sU.isSelected() || sO.isSelected() || b.isSelected() || sI.isSelected()))
              {
               ipv6.setSelected(false);   
               ipv6.setEnabled(false);  
               f.setEnabled(true);
              }
           }
    }//GEN-LAST:event_sTItemStateChanged
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void P0ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_P0ItemStateChanged
       if(P0.isSelected())
         {
          initial_rtt_to.setEnabled(true);
          PP.setSelected(false);
          PP.setEnabled(false);
          PM.setSelected(false);
          PM.setEnabled(false);
          PB.setSelected(false);
          PB.setEnabled(false);
          PE.setSelected(false);
          PE.setEnabled(false);
          PA.setSelected(false);
          PA.setEnabled(false);
          PA_port.setText("[portlist]");
          PA_port.setEnabled(false);
          PS.setSelected(false);
          PS.setEnabled(false);
          PS_port.setText("[portlist]");
          PS_port.setEnabled(false);
          PU.setSelected(false);
          PU.setEnabled(false);
          PU_port.setText("[portlist]");
          PU_port.setEnabled(false);

         }
       
       else
           {
            initial_rtt_to.setSelected(false);   
            initial_rtt_to.setEnabled(false);
            initial_rtt_to_ms.setText("6000");
            initial_rtt_to_ms.setEnabled(false);
            PP.setEnabled(true);
            PM.setEnabled(true);
            PA.setEnabled(true);
            PB.setEnabled(true);
            PE.setEnabled(true);
            PA_port.setText("[portlist]");
            PS.setEnabled(true);
            PS_port.setText("[portlist]");
            PU.setEnabled(true);
            PU_port.setText("[portlist]");
           }
    }//GEN-LAST:event_P0ItemStateChanged

    private void sUItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_sUItemStateChanged
        if(sU.isSelected())
          {
           sL.setSelected(false);
           sL.setEnabled(false);
           sP.setSelected(false);
           sP.setEnabled(false);
           f.setSelected(false);
           f.setEnabled(false);
           
           if(sT.isSelected()) { ipv6.setSelected(false); ipv6.setEnabled(false); }
          }
        
        else
            {
             if(!O.isSelected()) { sP.setEnabled(true); sL.setEnabled(true); }   
             
             if(sT.isSelected() && !sR.isSelected()) { ipv6.setEnabled(true); }
             
             if(!(sL.isSelected() || sT.isSelected() || sP.isSelected() || sO.isSelected() || b.isSelected() || sI.isSelected())) { f.setEnabled(true); }
            }
    }//GEN-LAST:event_sUItemStateChanged
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void sLItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_sLItemStateChanged
        if(sL.isSelected())
          {
           P0.setSelected(false);
           P0.setEnabled(false);
           F.setSelected(false);
           F.setEnabled(false);
           sU.setSelected(false);
           sU.setEnabled(false);
           O.setSelected(false);
           O.setEnabled(false);
           f.setSelected(false);
           f.setEnabled(false);
           sR.setSelected(false);
           sR.setEnabled(false);
           sV.setSelected(false);
           sV.setEnabled(false);
           ipv6.setEnabled(true); //Nmap 3.81 supporta questa opzione solo per sT, sL, sP Scan Mode.
          }
        
        else
           {
            if(!sP.isSelected()) { O.setEnabled(true); }   
               
            if(!sO.isSelected() || !sP.isSelected()) { sR.setEnabled(true); }
            
            if(!sO.isSelected()) { sV.setEnabled(true); }   
               
            if(!sP.isSelected() && !sO.isSelected())
              {
               P0.setEnabled(true);
               F.setEnabled(true);
               sU.setEnabled(true);
              }    
            
            if(!(sT.isSelected() || sP.isSelected() || sO.isSelected() || sU.isSelected() || b.isSelected() || sI.isSelected()))
              {
               ipv6.setSelected(false);   
               ipv6.setEnabled(false);  
               f.setEnabled(true);
              }
           }
    }//GEN-LAST:event_sLItemStateChanged
    
    /** 
      Metodo utilizzato per la gestione delle "politiche grafiche" dei bottoni del front-end.
      @param evt Un ItemEvent.
    */
    private void sPItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_sPItemStateChanged
        if(sP.isSelected())
          {
           P0.setSelected(false);
           P0.setEnabled(false);
           F.setSelected(false);
           F.setEnabled(false);
           sU.setSelected(false);
           sU.setEnabled(false);
           O.setSelected(false);
           O.setEnabled(false);
           f.setSelected(false);
           f.setEnabled(false);
           sR.setSelected(false);
           sR.setEnabled(false);
           sV.setSelected(false);
           sV.setEnabled(false);
           ipv6.setEnabled(true); //Nmap 3.81 supporta questa opzione solo per sT, sL, sP Scan Mode.
          }
        
        else
           {
            if(!sL.isSelected()) { O.setEnabled(true); }   
               
            if(!sO.isSelected() || !sL.isSelected()) { sR.setEnabled(true); }
            
            if(!sO.isSelected()) { sV.setEnabled(true); }
            
            if(!sL.isSelected() && !sO.isSelected())
              {
               P0.setEnabled(true);
               F.setEnabled(true);
               sU.setEnabled(true);
              }
            
            if(!(sL.isSelected() || sT.isSelected() || sO.isSelected() || sU.isSelected() || b.isSelected() || sI.isSelected()))
              {
               ipv6.setSelected(false);   
               ipv6.setEnabled(false);  
               f.setEnabled(true);
              }
           }
    }//GEN-LAST:event_sPItemStateChanged

    /** 
      I Metodo utilizzato *MouseClicked sono utilizzati per la gestione delle "politiche grafiche" dei bottoni 
      e dei campi testuali del front-end.
      @param evt Un MouseEvent.
    */
    private void min_sdMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_min_sdMouseClicked
        if(min_sd.isSelected()) { min_sd_s.setEnabled(true); min_sd_s.selectAll(); min_sd.transferFocus(); }
        
        else { min_sd_s.setText("6000"); min_sd_s.setEnabled(false); }
    }//GEN-LAST:event_min_sdMouseClicked

    private void max_sdMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_max_sdMouseClicked
        if(max_sd.isSelected()) { max_sd_s.setEnabled(true); max_sd_s.selectAll(); max_sd.transferFocus(); }
        
        else { max_sd_s.setText("6000"); max_sd_s.setEnabled(false); }
    }//GEN-LAST:event_max_sdMouseClicked
 
    private void min_parMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_min_parMouseClicked
        if(min_par.isSelected()) { min_par_n.setEnabled(true); min_par_n.selectAll(); min_par.transferFocus(); }
        
        else { min_par_n.setText("1"); min_par_n.setEnabled(false); }
    }//GEN-LAST:event_min_parMouseClicked

    private void max_parMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_max_parMouseClicked
        if(max_par.isSelected()) { max_par_n.setEnabled(true); max_par_n.selectAll(); max_par.transferFocus(); }
        
        else { max_par_n.setText("1"); max_par_n.setEnabled(false); }
    }//GEN-LAST:event_max_parMouseClicked
 
    private void min_hostgroupMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_min_hostgroupMouseClicked
        if(min_hostgroup.isSelected()) { min_hostgroup_infos.setEnabled(true); min_hostgroup_infos.selectAll(); min_hostgroup.transferFocus(); }
        
        else { min_hostgroup_infos.setText("50"); min_hostgroup_infos.setEnabled(false); }
    }//GEN-LAST:event_min_hostgroupMouseClicked

    private void max_hostgroupMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_max_hostgroupMouseClicked
        if(max_hostgroup.isSelected()) { max_hostgroup_infos.setEnabled(true); max_hostgroup_infos.selectAll(); max_hostgroup.transferFocus(); }
        
        else { max_hostgroup_infos.setText("50"); max_hostgroup_infos.setEnabled(false); }
    }//GEN-LAST:event_max_hostgroupMouseClicked
 
    private void initial_rtt_toMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_initial_rtt_toMouseClicked
        if(initial_rtt_to.isSelected()) { initial_rtt_to_ms.setEnabled(true); initial_rtt_to_ms.selectAll(); initial_rtt_to.transferFocus(); }
        
        else { initial_rtt_to_ms.setText("6000"); initial_rtt_to_ms.setEnabled(false); }
    }//GEN-LAST:event_initial_rtt_toMouseClicked
 
    private void min_rtt_toMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_min_rtt_toMouseClicked
        if(min_rtt_to.isSelected()) { min_rtt_to_ms.setEnabled(true); min_rtt_to_ms.selectAll(); min_rtt_to.transferFocus(); }
        
        else { min_rtt_to_ms.setText("6000"); min_rtt_to_ms.setEnabled(false); }
    }//GEN-LAST:event_min_rtt_toMouseClicked

    private void max_rtt_toMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_max_rtt_toMouseClicked
        if(max_rtt_to.isSelected()) { max_rtt_to_ms.setEnabled(true); max_rtt_to_ms.selectAll(); max_rtt_to.transferFocus(); }
        
        else { max_rtt_to_ms.setText("6000"); max_rtt_to_ms.setEnabled(false); }
    }//GEN-LAST:event_max_rtt_toMouseClicked

    private void host_timeoutMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_host_timeoutMouseClicked
        if(host_timeout.isSelected()) { host_timeout_ms.setEnabled(true); host_timeout_ms.selectAll(); host_timeout.transferFocus(); }
        
        else { host_timeout_ms.setText("6000"); host_timeout_ms.setEnabled(false); }
    }//GEN-LAST:event_host_timeoutMouseClicked
 
    private void bMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_bMouseClicked
        if(b.isSelected()) { b.transferFocus(); }
    }//GEN-LAST:event_bMouseClicked

    private void sIMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_sIMouseClicked
        if(sI.isSelected()) { sI.transferFocus(); }
    }//GEN-LAST:event_sIMouseClicked

    private void DMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_DMouseClicked
        if(D.isSelected()) { D_infos.setEnabled(true); D_infos.setText(""); D.transferFocus(); }
        
        else { D_infos.setText("<decoy1,decoy2,ME,...>"); D_infos.setEnabled(false); }
    }//GEN-LAST:event_DMouseClicked

    private void SMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SMouseClicked
        if(S.isSelected()) { S_infos.setEnabled(true); S_infos.setText(""); S.transferFocus(); }
        
        else { S_infos.setText("Your IP_Address"); S_infos.setEnabled(false); }
    }//GEN-LAST:event_SMouseClicked

    private void MMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_MMouseClicked
        if(M.isSelected()) { M_infos.setEnabled(true); M.transferFocus(); M_infos.select(4,4); }
        
        else { M_infos.setText("1024"); M_infos.setEnabled(false); }
    }//GEN-LAST:event_MMouseClicked

    private void eMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_eMouseClicked
        if(e.isSelected()) 
          {
           e_infos.setEnabled(true);   
           e.transferFocus(); 
           e_infos.select(4,4);
          }
        
        else { e_infos.setEnabled(false); }
    }//GEN-LAST:event_eMouseClicked

    private void iRMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_iRMouseClicked
        if(iR.isSelected()) { iR_infos.setEnabled(true); iR_infos.setText(""); iR.transferFocus(); }
        
        else { iR_infos.setEnabled(false); iR_infos.setText("1 [0 for crazy!]"); }
    }//GEN-LAST:event_iRMouseClicked

    private void ttlMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ttlMouseClicked
        if(ttl.isSelected()) { ttl_infos.setEnabled(true); ttl.transferFocus(); }
        
        else { ttl_infos.setEnabled(false); }
    }//GEN-LAST:event_ttlMouseClicked

    private void data_lengthMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_data_lengthMouseClicked
        if(data_length.isSelected()) { data_length_infos.setEnabled(true); data_length_infos.setText(""); data_length.transferFocus(); }
        
        else { data_length_infos.setText("<Dim. payload>"); data_length_infos.setEnabled(false); }
    }//GEN-LAST:event_data_lengthMouseClicked

    private void source_portMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_source_portMouseClicked
        if(source_port.isSelected()) { source_port_infos. setEnabled(true); source_port.transferFocus(); source_port_infos.select(5,5); }
        
        else { source_port_infos. setEnabled(false); source_port_infos.setText("53,20"); }
    }//GEN-LAST:event_source_portMouseClicked

    private void excludeMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_excludeMouseClicked
        if(exclude.isSelected()) { exclude_infos.setEnabled(true); exclude_infos.setText(""); exclude.transferFocus(); }
        
        else { exclude_infos.setEnabled(false); exclude_infos.setText("<host1,host2,..>"); }
    }//GEN-LAST:event_excludeMouseClicked

    private void PUMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_PUMouseClicked
        if(PU.isSelected()) { PU_port.setEnabled(true); PU_port.setText(""); PU.transferFocus(); }
        
        else { PU_port.setText("[portlist]"); PU_port.setEnabled(false); }
    }//GEN-LAST:event_PUMouseClicked

    private void PSMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_PSMouseClicked
        if(PS.isSelected()) { PS_port.setEnabled(true); PS_port.setText(""); PS.transferFocus(); }
        
        else { PS_port.setText("[portlist]"); PS_port.setEnabled(false); }
    }//GEN-LAST:event_PSMouseClicked

    private void PAMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_PAMouseClicked
        if(PA.isSelected()) { PA_port.setEnabled(true); PA_port.setText(""); PA.transferFocus(); }
        
        else { PA_port.setText("[portlist]"); PA_port.setEnabled(false); }
    }//GEN-LAST:event_PAMouseClicked

    private void button_helpTActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_helpTActionPerformed
       jPMenu_helpT.insert(Text_helpT,0);
       jPMenu_helpT.show(button_helpT, 5, 25);
    }//GEN-LAST:event_button_helpTActionPerformed

    /** 
      Intercettatore del bottone "Options Help" del tab "Scan Mode". Il metodo lancia un terminale visualizzando la
      pagina man per nmap.
      @param evt Un ActionEvent.
     */
    private void button_ohActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_ohActionPerformed
       try
         {
          Runtime help = Runtime.getRuntime();   
          Process man_nmap = help.exec("gnome-terminal -x man nmap");
         }
                
       catch(IOException e) { System.out.println("Error launching: gnome-terminal -x man nmap"); }
    }//GEN-LAST:event_button_ohActionPerformed

    /** 
      Intercettatore del bottone "Reset" del tab "Scan Results". Il metodo cancella il contenuto della finestra dei
      risultati ottenuti da nmap.
      @param evt Un ActionEvent.
     */
    private void button_resetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_resetActionPerformed
        textresult.setEnabled(true);
        textresult.selectAll();
        textresult.replaceSelection("");
        textresult.setEditable(false);
    }//GEN-LAST:event_button_resetActionPerformed

     /**     
      Intercettatore del bottone "Save Result" del tab "Scan Results". Il metodo permette il salvataggio sul disco,
      in formato testuale, dei risultati ottenuti da nmap.
      @param evt Un ActionEvent.      
     */
    private void button_saveresActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_saveresActionPerformed
         FileChooser.addChoosableFileFilter(new TxtFileFilter());
            
         if(FileChooser.showSaveDialog(null) == FileChooser.APPROVE_OPTION)
            {
             File file_f = FileChooser.getSelectedFile(); //File selezionato.
             
             String path = file_f.getAbsolutePath();
             
             PrintWriter write = buildOut(path); //Creazione del descrittore per il file.
             
             if(write == null)
               {
                System.out.println("Writing error! Check your directory permissions!"); 
               }
           
             else
                 {
                  write.println(textresult.getText());
                  write.flush();
                 }
             }
    }//GEN-LAST:event_button_saveresActionPerformed

    /** 
      Intercettatore per l'uscita dal programma. 
      @param evt Un ActionEvent. 
     */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
  
    /** 
      Metodo per la generazione della stringa di parametri di ScanMode da passare ad nmap.
      @return Una stringa di parametri. 
     */
    private String bScanModeOptions()
      {
       if(sS.isSelected()) { return " -sS"; }
       
       if(sT.isSelected()) { return " -sT"; }
       
       if(sF.isSelected()) { return " -sF"; }
       
       if(sX.isSelected()) { return " -sX"; }       

       if(sN.isSelected()) { return " -sN"; }
       
       if(sA.isSelected()) { return " -sS"; } 
        
       if(sW.isSelected()) { return " -sW"; }
       
       if(sL.isSelected()) { return " -sL"; }
       
       if(sP.isSelected()) { return " -sP"; }
       
       if(sO.isSelected()) { return " -sO"; }
       
       if(sM.isSelected()) { return " -sM"; }
       
       if(sI.isSelected()) { return " -sI " + tfield_sI.getText(); }
       
       if(b.isSelected()) { return " -b " + tfield_b.getText(); }
       
       return "";
      }
    
    /** 
      Metodo per la generazione della stringa di parametri di ScanMode Options da passare ad nmap.
      @return Una stringa di parametri. 
     */
    private String bSMOptions()
      {
       String param = "";   
          
       if(sV.isSelected()) { param = param.concat(" -sV"); }
       
       if(sU.isSelected()) { param = param.concat(" -sU"); }
       
       if(O.isSelected()) { param = param.concat(" -O"); }
       
       if(I.isSelected()) { param = param.concat(" -I"); }
       
       if(sR.isSelected()) { param = param.concat(" -sR"); }
          
       return param;
      }
 
    /** 
      Metodo per la generazione della stringa di parametri di General Options da passare ad nmap.
      @return Una stringa di parametri. 
     */    
    private String bGeneralOptions()
      {
       String options = "";
       
       if(PA.isSelected()) { options = options.concat(" -PA" + PA_port.getText()); }
       
       if(PS.isSelected()) { options = options.concat(" -PS" + PS_port.getText()); }
       
       if(PU.isSelected()) { options = options.concat(" -PU" + PU_port.getText()); }
       
       if(PB.isSelected()) { options = options.concat(" -PB"); }
       
       if(P0.isSelected()) { options = options.concat(" -P0"); }
       
       if(PE.isSelected()) { options = options.concat(" -PE"); }
       
       if(PP.isSelected()) { options = options.concat(" -PP"); }
       
       if(PM.isSelected()) { options = options.concat(" -PM"); }
       
       if(ipv6.isSelected()) { options = options.concat(" -6"); }
       
       if(osscan_limit.isSelected()) { options = options.concat(" --osscan_limit"); }
       
       if(exclude.isSelected()) { options = options.concat(" --exclude " + exclude_infos.getText()); }
       
       if(source_port.isSelected()) { options = options.concat(" --source_port " + source_port_infos.getText()); }
       
       if(data_length.isSelected()) { options = options.concat(" --data_length " + data_length_infos.getText()); }
       
       if(iR.isSelected()) { options = options.concat(" -iR " + iR_infos.getText()); }
       
       if(p.isSelected()) { options = options.concat(" -p " + p_TCPport.getText()) + "," + p_UDPport.getText(); }
       
       if(p_all.isSelected()) { options = options.concat(" -p-"); }
       
       if(D.isSelected()) { options = options.concat(" -D " + D_infos.getText()); }
       
       if(S.isSelected()) { options = options.concat(" -S " + S_infos.getText()); }
       
       if(e.isSelected()) { options = options.concat(" -e " + e_infos.getText()); }
       
       if(f.isSelected()) { options = options.concat(" -f"); }
       
       if(v.isSelected()) { options = options.concat(" -v"); }
       
       if(d.isSelected()) { options = options.concat(" -d"); }
       
       if(F.isSelected()) { options = options.concat(" -F"); }
       
       if(n.isSelected()) { options = options.concat(" -n"); }
       
       if(R.isSelected()) { options = options.concat(" -R"); }
       
       if(r.isSelected()) { options = options.concat(" -r"); }
       
       if(M.isSelected()) { options = options.concat(" -M " + M_infos.getText()); }
       
       if(ttl.isSelected()) { options = options.concat(" --ttl " + ttl_infos.getText()); }
       
       if(randomize_hosts.isSelected()) { options = options.concat(" --randomize_hosts"); }
       
       return options;
      }
 
    /** 
      Metodo per la generazione della stringa di parametri di Timing da passare ad nmap.
      @return Una stringa di parametri. 
     */    
    private String bTimingOptions()
      {
       String toptions = "";
      
       if(T.isSelected()) { toptions = toptions.concat(" -T " + (String)T_cbox.getSelectedItem()); }
       
       if(host_timeout.isSelected()) { toptions = toptions.concat(" --host_timeout ") + host_timeout_ms.getText(); }
       
       if(max_rtt_to.isSelected()) { toptions = toptions.concat(" --max_rtt_timeout ") + max_rtt_to_ms.getText(); }
       
       if(min_rtt_to.isSelected()) { toptions = toptions.concat(" --min_rtt_timeout ") + min_rtt_to_ms.getText(); }
       
       if(initial_rtt_to.isSelected()) { toptions = toptions.concat(" --initial_rtt_timeout ") + initial_rtt_to_ms.getText(); }
       
       if(max_hostgroup.isSelected()) { toptions = toptions.concat(" --max_hostgroup ") + max_hostgroup_infos.getText(); }
       
       if(min_hostgroup.isSelected()) { toptions = toptions.concat(" --min_hostgroup ") + min_hostgroup_infos.getText(); }
       
       if(max_par.isSelected()) { toptions = toptions.concat(" --max_parallelism ") + max_par_n.getText(); }
       
       if(min_par.isSelected()) { toptions = toptions.concat(" --min_parallelism ") + min_par_n.getText(); }
       
       if(min_sd.isSelected()) { toptions = toptions.concat(" --scan_delay ") + min_sd_s.getText(); }
       
       if(max_sd.isSelected()) { toptions = toptions.concat(" --max_scan_delay ") + max_sd_s.getText(); }
      
       return toptions;
      }
 
    /** 
      Metodo per la generazione della stringa di parametri per il salvataggio dei risultati di nmap in
      diversi formati.
      @return Una stringa di parametri. 
     */       
    private String specialFileOptions()
      {
       String ss = "";
       
       if(oX.isSelected()) { ss = ss.concat(" -oX " + s_oX); }
       
       if(oG.isSelected()) { ss = ss.concat(" -oG " + s_oG); }
       
       if(oA.isSelected()) { ss = ss.concat(" -oA " + s_oA); }
       
       if(oS.isSelected()) { ss = ss.concat(" -oS " + s_oS); }
       
       if(iL.isSelected()) { ss = ss.concat(" -iL " + s_iL); }
       
       return ss;
      }
    
    /** 
      Metodo per la creazione di un file su hd.
      @param i La path e il nome del file che deve essere creato.
      @return Un descrittore per il file i o null in caso di errore.
    */
    private PrintWriter buildOut(String i)
      {
       try
         {
          FileWriter writer = new FileWriter(i);
          BufferedWriter buff = new BufferedWriter(writer);
          PrintWriter out = new PrintWriter(buff);

          return out;
         }

       catch(IOException e) { return null; } 	      	     
      }
    
    /**
      I seguenti metodi protected ritornano elementi grafici dichiarati private e non direttamente visibli da 
      altre classi.
      Il thread che gestisce il processo nmap deve essere in grado di dialogare con l'interfaccia per la
      visualizzazione dei risultati e per il setting di alcuni elementi grafici. 
     */  
    protected javax.swing.JTextArea getTextResult() { return textresult; }
    
    protected javax.swing.JTabbedPane getTabbed() { return Tabbed; }
    
    protected javax.swing.JTextField getTextIp() { return textip; }
    
    protected javax.swing.JButton getBSKill() { return button_kill; }
    
    protected javax.swing.JButton getBScan() { return button_scan; }
    
    protected javax.swing.JLabel getHostT() { return label_cht; }
    
    protected javax.swing.JLabel getCNmap() { return label_cnmap; }
    
    protected javax.swing.JLabel getStatusScan() { return label_ssrt; }
    
    protected javax.swing.JLabel getTimeInfos() { return label_ssc; }
    
    protected javax.swing.JLabel getIconScan() { return iconscan; }
    
    protected javax.swing.JLabel getLabelFocus() { return labelip; }
    
    protected javax.swing.JTextArea getAreaError() { return text_errorsr; }
    
    protected boolean getiLState() { return iL.isSelected(); }
    
    /**
     Metodo main della classe. Costruisce un nuovo oggetto Jnmap() e lo visualizza chiamando il metodo show().
     @param args Argomenti a linea di comando.
    */
    public static void main(String args[]) 
      {
       new Jnmap().show();
      }
    
    /**
      Inner class che estende la classe astratta FileFilter contenente i metodi:
      getDescription() e accept(). Questa classe implementa il filtraggio per i file
      compatibili con l'estensione tipica di file testuali. 
    */  
    private static class TxtFileFilter extends javax.swing.filechooser.FileFilter 
     {
      public boolean accept(File file) 
        {
         if(file == null) { return false; }
            
         return file.isDirectory() || file.getName().toLowerCase().endsWith(".txt") || file.getName().toLowerCase().endsWith(".nmap");
        }
        
        public String getDescription() 
          {
           return "Like Text Files (*.txt, *.nmap)";
          }    
      }
    
    /**
      Inner class che estende la classe astratta FileFilter contenente i metodi:
      getDescription() e accept(). Questa classe implementa il filtraggio per i file
      compatibili con l'estensione tipica di file XML. 
    */  
    private static class XMLFileFilter extends javax.swing.filechooser.FileFilter 
     {
      public boolean accept(File file) 
        {
         if(file == null) { return false; }
            
         return file.isDirectory() || file.getName().toLowerCase().endsWith(".xml");
        }
        
        public String getDescription() 
          {
           return "XML (*.xml)";
          }    
      }
    
    /**
      Inner class che estende la classe astratta FileFilter contenente i metodi:
      getDescription() e accept(). Questa classe implementa il filtraggio per i file
      compatibili con l'estensione .gnmap (grepable). 
    */  
    private static class grepFileFilter extends javax.swing.filechooser.FileFilter 
     {
      public boolean accept(File file) 
        {
         if(file == null) { return false; }
            
         return file.isDirectory() || file.getName().toLowerCase().endsWith(".gnmap");
        }
        
        public String getDescription() 
          {
           return "Grepable (*.gnmap)";
          }    
      }
    
    /**
      Inner class che estende la classe astratta FileFilter contenente i metodi:
      getDescription() e accept(). Questa classe implementa il filtraggio per i file
      compatibili con tutte le estensioni valide per il salvataggio. 
    */  
    private static class allFileFilter extends javax.swing.filechooser.FileFilter 
     {
      public boolean accept(File file) 
        {
         if (file == null)
           {
            return false;
           }
            
         return file.isDirectory() || file.getName().toLowerCase().endsWith(".txt") || file.getName().toLowerCase().endsWith(".nmap") || file.getName().toLowerCase().endsWith(".gnmap") || file.getName().toLowerCase().endsWith(".xml");
        }
        
        public String getDescription() 
          {
           return "All extensions (*.nmap, *.gnmap, *.xml, *.txt)";
          }    
      }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox D;
    private javax.swing.JTextField D_infos;
    private javax.swing.JCheckBox F;
    private javax.swing.JFileChooser FileChooser;
    private javax.swing.JPanel Globalpane;
    private javax.swing.ButtonGroup GroupSmode;
    private javax.swing.JCheckBox I;
    private javax.swing.JCheckBox M;
    private javax.swing.JTextField M_infos;
    private javax.swing.JCheckBox O;
    private javax.swing.JCheckBox P0;
    private javax.swing.JCheckBox PA;
    private javax.swing.JTextField PA_port;
    private javax.swing.JCheckBox PB;
    private javax.swing.JCheckBox PE;
    private javax.swing.JCheckBox PM;
    private javax.swing.JCheckBox PP;
    private javax.swing.JCheckBox PS;
    private javax.swing.JTextField PS_port;
    private javax.swing.JCheckBox PU;
    private javax.swing.JTextField PU_port;
    private javax.swing.JPanel PanelCombmode;
    private javax.swing.JPanel PanelExclmode;
    private javax.swing.JPanel PanelHelp;
    private javax.swing.JPanel PanelSmode;
    private javax.swing.JPanel Panel_C1;
    private javax.swing.JPanel Panel_C2;
    private javax.swing.JPanel Panel_C3;
    private javax.swing.JPanel Panel_DNSo;
    private javax.swing.JPanel Panel_ErrIm;
    private javax.swing.JPanel Panel_Genius;
    private javax.swing.JPanel Panel_Misc;
    private javax.swing.JPanel Panel_Parallel;
    private javax.swing.JPanel Panel_Pingo;
    private javax.swing.JPanel Panel_Ports;
    private javax.swing.JPanel Panel_RSS;
    private javax.swing.JPanel Panel_RSS1;
    private javax.swing.JPanel Panel_RSS2;
    private javax.swing.JPanel Panel_RSS3;
    private javax.swing.JPanel Panel_RSS4;
    private javax.swing.JPanel Panel_T1;
    private javax.swing.JPanel Panel_T2;
    private javax.swing.JPanel Panel_TDO;
    private javax.swing.JPanel Panel_Thrott;
    private javax.swing.JPanel Panel_Verbosity;
    private javax.swing.JPanel Panel_credits;
    private javax.swing.JPanel Panel_iL;
    private javax.swing.JPanel Panel_oA;
    private javax.swing.JPanel Panel_oG;
    private javax.swing.JPanel Panel_oS;
    private javax.swing.JPanel Panel_oX;
    private javax.swing.JPanel Panel_space;
    private javax.swing.JPanel Panelresults;
    private javax.swing.JCheckBox R;
    private javax.swing.JCheckBox S;
    private javax.swing.JTextField S_infos;
    private javax.swing.JScrollPane Scroll_error;
    private javax.swing.JScrollPane Scrolltextres;
    private javax.swing.JPanel Startpane;
    private javax.swing.JCheckBox T;
    private javax.swing.JComboBox T_cbox;
    private javax.swing.JTabbedPane Tabbed;
    private javax.swing.JTextArea Text_credits1;
    private javax.swing.JTextArea Text_credits2;
    private javax.swing.JTextArea Text_credits3;
    private javax.swing.JTextArea Text_helpT;
    private javax.swing.JCheckBox b;
    private javax.swing.JButton button_helpT;
    private javax.swing.JButton button_kill;
    private javax.swing.JButton button_oh;
    private javax.swing.JButton button_reset;
    private javax.swing.JButton button_saveres;
    private javax.swing.JButton button_scan;
    private javax.swing.JCheckBox d;
    private javax.swing.JCheckBox data_length;
    private javax.swing.JTextField data_length_infos;
    private javax.swing.JCheckBox e;
    private javax.swing.JTextField e_infos;
    private javax.swing.JCheckBox exclude;
    private javax.swing.JTextField exclude_infos;
    private javax.swing.JCheckBox f;
    private javax.swing.JCheckBox host_timeout;
    private javax.swing.JTextField host_timeout_ms;
    private javax.swing.JCheckBox iL;
    private javax.swing.JCheckBox iR;
    private javax.swing.JTextField iR_infos;
    private javax.swing.JLabel iconscan;
    private javax.swing.JLabel info_crash;
    private javax.swing.JCheckBox initial_rtt_to;
    private javax.swing.JTextField initial_rtt_to_ms;
    private javax.swing.JCheckBox ipv6;
    private javax.swing.JPopupMenu jPMenu_helpT;
    private javax.swing.JLabel label_cht;
    private javax.swing.JLabel label_cn;
    private javax.swing.JLabel label_cnmap;
    private javax.swing.JLabel label_ht;
    private javax.swing.JLabel label_inforoot;
    private javax.swing.JLabel label_logo;
    private javax.swing.JLabel label_path;
    private javax.swing.JLabel label_path1;
    private javax.swing.JLabel label_path2;
    private javax.swing.JLabel label_path3;
    private javax.swing.JLabel label_path4;
    private javax.swing.JLabel label_separator;
    private javax.swing.JLabel label_separator1;
    private javax.swing.JLabel label_sepsr;
    private javax.swing.JLabel label_ss;
    private javax.swing.JLabel label_ssc;
    private javax.swing.JLabel label_ssi;
    private javax.swing.JLabel label_ssrt;
    private javax.swing.JLabel labelip;
    private javax.swing.JCheckBox max_hostgroup;
    private javax.swing.JTextField max_hostgroup_infos;
    private javax.swing.JCheckBox max_par;
    private javax.swing.JTextField max_par_n;
    private javax.swing.JCheckBox max_rtt_to;
    private javax.swing.JTextField max_rtt_to_ms;
    private javax.swing.JCheckBox max_sd;
    private javax.swing.JTextField max_sd_s;
    private javax.swing.JCheckBox min_hostgroup;
    private javax.swing.JTextField min_hostgroup_infos;
    private javax.swing.JCheckBox min_par;
    private javax.swing.JTextField min_par_n;
    private javax.swing.JCheckBox min_rtt_to;
    private javax.swing.JTextField min_rtt_to_ms;
    private javax.swing.JCheckBox min_sd;
    private javax.swing.JTextField min_sd_s;
    private javax.swing.JLabel ms;
    private javax.swing.JLabel ms1;
    private javax.swing.JLabel ms2;
    private javax.swing.JLabel ms5;
    private javax.swing.JLabel ms6;
    private javax.swing.JLabel ms7;
    private javax.swing.JCheckBox n;
    private javax.swing.JCheckBox oA;
    private javax.swing.JCheckBox oG;
    private javax.swing.JCheckBox oS;
    private javax.swing.JCheckBox oX;
    private javax.swing.JCheckBox osscan_limit;
    private javax.swing.JCheckBox p;
    private javax.swing.JTextField p_TCPport;
    private javax.swing.JTextField p_UDPport;
    private javax.swing.JCheckBox p_all;
    private javax.swing.JCheckBox r;
    private javax.swing.JCheckBox randomize_hosts;
    private javax.swing.JCheckBox sA;
    private javax.swing.JCheckBox sF;
    private javax.swing.JCheckBox sI;
    private javax.swing.JCheckBox sL;
    private javax.swing.JCheckBox sM;
    private javax.swing.JCheckBox sN;
    private javax.swing.JCheckBox sO;
    private javax.swing.JCheckBox sP;
    private javax.swing.JCheckBox sR;
    private javax.swing.JCheckBox sS;
    private javax.swing.JCheckBox sT;
    private javax.swing.JCheckBox sU;
    private javax.swing.JCheckBox sV;
    private javax.swing.JCheckBox sW;
    private javax.swing.JCheckBox sX;
    private javax.swing.JButton select_button;
    private javax.swing.JButton select_button1;
    private javax.swing.JButton select_button2;
    private javax.swing.JButton select_button3;
    private javax.swing.JButton select_button4;
    private javax.swing.JLabel sep10;
    private javax.swing.JLabel sep11;
    private javax.swing.JLabel sep1_smo;
    private javax.swing.JLabel sep1_smo1;
    private javax.swing.JLabel sep1_smo2;
    private javax.swing.JLabel sep1_smo3;
    private javax.swing.JLabel sep2;
    private javax.swing.JLabel sep2_smo;
    private javax.swing.JLabel sep3;
    private javax.swing.JLabel sep4;
    private javax.swing.JLabel sep5;
    private javax.swing.JLabel sep6;
    private javax.swing.JLabel sep7;
    private javax.swing.JLabel sep8;
    private javax.swing.JLabel sep9;
    private javax.swing.JCheckBox source_port;
    private javax.swing.JTextField source_port_infos;
    private javax.swing.JPanel tab_credits;
    private javax.swing.JPanel tab_goptions;
    private javax.swing.JPanel tab_running;
    private javax.swing.JPanel tab_scan;
    private javax.swing.JPanel tab_scanmode;
    private javax.swing.JPanel tab_specials;
    private javax.swing.JPanel tab_timing;
    private javax.swing.JTextArea text_errorsr;
    private javax.swing.JTextField text_path;
    private javax.swing.JTextField text_path1;
    private javax.swing.JTextField text_path2;
    private javax.swing.JTextField text_path3;
    private javax.swing.JTextField text_path4;
    private javax.swing.JTextField textip;
    private javax.swing.JTextArea textresult;
    private javax.swing.JTextField tfield_b;
    private javax.swing.JTextField tfield_sI;
    private javax.swing.JCheckBox ttl;
    private javax.swing.JTextField ttl_infos;
    private javax.swing.JCheckBox v;
    // End of variables declaration//GEN-END:variables
}